// generated by SMACK version 2.4.0 for boogie
// via /usr/local/bin/smack two_arrays.c --loop-limit=11 --unroll=11 --verifier=boogie --debug --bpl=pero.bpl

// RUN: %parallel-boogie -doModSetAnalysis -timeLimit:1200 -errorLimit:1 -loopUnroll:15 "%s" > "%t"
// RUN: %diff "%s.expect" "%t"

// Basic types
type i1 = int;
type i5 = int;
type i6 = int;
type i8 = int;
type i16 = int;
type i24 = int;
type i32 = int;
type i40 = int;
type i48 = int;
type i56 = int;
type i64 = int;
type i80 = int;
type i88 = int;
type i96 = int;
type i128 = int;
type i160 = int;
type i256 = int;
type ref = i64;
type float;

// Basic constants
const $0: i32;
axiom ($0 == 0);
const $1: i32;
axiom ($1 == 1);
const $0.ref: ref;
axiom ($0.ref == 0);
const $1.ref: ref;
axiom ($1.ref == 1);
const $1024.ref: ref;
axiom ($1024.ref == 1024);
// Memory model constants
const $GLOBALS_BOTTOM: ref;
const $EXTERNS_BOTTOM: ref;
const $MALLOC_TOP: ref;

// Memory maps (3 regions)
var $M.0: [ref] i32;
var $M.1: ref;
var $M.2: i32;

// Memory address bounds
axiom ($GLOBALS_BOTTOM == $sub.ref(0, 47475));
axiom ($EXTERNS_BOTTOM == $add.ref($GLOBALS_BOTTOM, $sub.ref(0, 32768)));
axiom ($MALLOC_TOP == 9223372036854775807);
function {:define} $isExternal(p: ref) returns (bool) { $slt.ref.bool(p, $EXTERNS_BOTTOM) }

// SMT bit-vector/integer conversion
function {:builtin "(_ int2bv 64)"} $int2bv.64(i: i64) returns (bv64);
function {:builtin "bv2nat"} $bv2int.64(i: bv64) returns (i64);

// Integer arithmetic operations
function {:define} $add.i1(i1: i1, i2: i1) returns (i1) { (i1 + i2) }
function {:define} $add.i5(i1: i5, i2: i5) returns (i5) { (i1 + i2) }
function {:define} $add.i6(i1: i6, i2: i6) returns (i6) { (i1 + i2) }
function {:define} $add.i8(i1: i8, i2: i8) returns (i8) { (i1 + i2) }
function {:define} $add.i16(i1: i16, i2: i16) returns (i16) { (i1 + i2) }
function {:define} $add.i24(i1: i24, i2: i24) returns (i24) { (i1 + i2) }
function {:define} $add.i32(i1: i32, i2: i32) returns (i32) { (i1 + i2) }
function {:define} $add.i40(i1: i40, i2: i40) returns (i40) { (i1 + i2) }
function {:define} $add.i48(i1: i48, i2: i48) returns (i48) { (i1 + i2) }
function {:define} $add.i56(i1: i56, i2: i56) returns (i56) { (i1 + i2) }
function {:define} $add.i64(i1: i64, i2: i64) returns (i64) { (i1 + i2) }
function {:define} $add.i80(i1: i80, i2: i80) returns (i80) { (i1 + i2) }
function {:define} $add.i88(i1: i88, i2: i88) returns (i88) { (i1 + i2) }
function {:define} $add.i96(i1: i96, i2: i96) returns (i96) { (i1 + i2) }
function {:define} $add.i128(i1: i128, i2: i128) returns (i128) { (i1 + i2) }
function {:define} $add.i160(i1: i160, i2: i160) returns (i160) { (i1 + i2) }
function {:define} $add.i256(i1: i256, i2: i256) returns (i256) { (i1 + i2) }
function {:define} $sub.i1(i1: i1, i2: i1) returns (i1) { (i1 - i2) }
function {:define} $sub.i5(i1: i5, i2: i5) returns (i5) { (i1 - i2) }
function {:define} $sub.i6(i1: i6, i2: i6) returns (i6) { (i1 - i2) }
function {:define} $sub.i8(i1: i8, i2: i8) returns (i8) { (i1 - i2) }
function {:define} $sub.i16(i1: i16, i2: i16) returns (i16) { (i1 - i2) }
function {:define} $sub.i24(i1: i24, i2: i24) returns (i24) { (i1 - i2) }
function {:define} $sub.i32(i1: i32, i2: i32) returns (i32) { (i1 - i2) }
function {:define} $sub.i40(i1: i40, i2: i40) returns (i40) { (i1 - i2) }
function {:define} $sub.i48(i1: i48, i2: i48) returns (i48) { (i1 - i2) }
function {:define} $sub.i56(i1: i56, i2: i56) returns (i56) { (i1 - i2) }
function {:define} $sub.i64(i1: i64, i2: i64) returns (i64) { (i1 - i2) }
function {:define} $sub.i80(i1: i80, i2: i80) returns (i80) { (i1 - i2) }
function {:define} $sub.i88(i1: i88, i2: i88) returns (i88) { (i1 - i2) }
function {:define} $sub.i96(i1: i96, i2: i96) returns (i96) { (i1 - i2) }
function {:define} $sub.i128(i1: i128, i2: i128) returns (i128) { (i1 - i2) }
function {:define} $sub.i160(i1: i160, i2: i160) returns (i160) { (i1 - i2) }
function {:define} $sub.i256(i1: i256, i2: i256) returns (i256) { (i1 - i2) }
function {:define} $mul.i1(i1: i1, i2: i1) returns (i1) { (i1 * i2) }
function {:define} $mul.i5(i1: i5, i2: i5) returns (i5) { (i1 * i2) }
function {:define} $mul.i6(i1: i6, i2: i6) returns (i6) { (i1 * i2) }
function {:define} $mul.i8(i1: i8, i2: i8) returns (i8) { (i1 * i2) }
function {:define} $mul.i16(i1: i16, i2: i16) returns (i16) { (i1 * i2) }
function {:define} $mul.i24(i1: i24, i2: i24) returns (i24) { (i1 * i2) }
function {:define} $mul.i32(i1: i32, i2: i32) returns (i32) { (i1 * i2) }
function {:define} $mul.i40(i1: i40, i2: i40) returns (i40) { (i1 * i2) }
function {:define} $mul.i48(i1: i48, i2: i48) returns (i48) { (i1 * i2) }
function {:define} $mul.i56(i1: i56, i2: i56) returns (i56) { (i1 * i2) }
function {:define} $mul.i64(i1: i64, i2: i64) returns (i64) { (i1 * i2) }
function {:define} $mul.i80(i1: i80, i2: i80) returns (i80) { (i1 * i2) }
function {:define} $mul.i88(i1: i88, i2: i88) returns (i88) { (i1 * i2) }
function {:define} $mul.i96(i1: i96, i2: i96) returns (i96) { (i1 * i2) }
function {:define} $mul.i128(i1: i128, i2: i128) returns (i128) { (i1 * i2) }
function {:define} $mul.i160(i1: i160, i2: i160) returns (i160) { (i1 * i2) }
function {:define} $mul.i256(i1: i256, i2: i256) returns (i256) { (i1 * i2) }
function {:builtin "div"} $sdiv.i1(i1: i1, i2: i1) returns (i1);
function {:builtin "div"} $sdiv.i5(i1: i5, i2: i5) returns (i5);
function {:builtin "div"} $sdiv.i6(i1: i6, i2: i6) returns (i6);
function {:builtin "div"} $sdiv.i8(i1: i8, i2: i8) returns (i8);
function {:builtin "div"} $sdiv.i16(i1: i16, i2: i16) returns (i16);
function {:builtin "div"} $sdiv.i24(i1: i24, i2: i24) returns (i24);
function {:builtin "div"} $sdiv.i32(i1: i32, i2: i32) returns (i32);
function {:builtin "div"} $sdiv.i40(i1: i40, i2: i40) returns (i40);
function {:builtin "div"} $sdiv.i48(i1: i48, i2: i48) returns (i48);
function {:builtin "div"} $sdiv.i56(i1: i56, i2: i56) returns (i56);
function {:builtin "div"} $sdiv.i64(i1: i64, i2: i64) returns (i64);
function {:builtin "div"} $sdiv.i80(i1: i80, i2: i80) returns (i80);
function {:builtin "div"} $sdiv.i88(i1: i88, i2: i88) returns (i88);
function {:builtin "div"} $sdiv.i96(i1: i96, i2: i96) returns (i96);
function {:builtin "div"} $sdiv.i128(i1: i128, i2: i128) returns (i128);
function {:builtin "div"} $sdiv.i160(i1: i160, i2: i160) returns (i160);
function {:builtin "div"} $sdiv.i256(i1: i256, i2: i256) returns (i256);
function {:builtin "mod"} $smod.i1(i1: i1, i2: i1) returns (i1);
function {:builtin "mod"} $smod.i5(i1: i5, i2: i5) returns (i5);
function {:builtin "mod"} $smod.i6(i1: i6, i2: i6) returns (i6);
function {:builtin "mod"} $smod.i8(i1: i8, i2: i8) returns (i8);
function {:builtin "mod"} $smod.i16(i1: i16, i2: i16) returns (i16);
function {:builtin "mod"} $smod.i24(i1: i24, i2: i24) returns (i24);
function {:builtin "mod"} $smod.i32(i1: i32, i2: i32) returns (i32);
function {:builtin "mod"} $smod.i40(i1: i40, i2: i40) returns (i40);
function {:builtin "mod"} $smod.i48(i1: i48, i2: i48) returns (i48);
function {:builtin "mod"} $smod.i56(i1: i56, i2: i56) returns (i56);
function {:builtin "mod"} $smod.i64(i1: i64, i2: i64) returns (i64);
function {:builtin "mod"} $smod.i80(i1: i80, i2: i80) returns (i80);
function {:builtin "mod"} $smod.i88(i1: i88, i2: i88) returns (i88);
function {:builtin "mod"} $smod.i96(i1: i96, i2: i96) returns (i96);
function {:builtin "mod"} $smod.i128(i1: i128, i2: i128) returns (i128);
function {:builtin "mod"} $smod.i160(i1: i160, i2: i160) returns (i160);
function {:builtin "mod"} $smod.i256(i1: i256, i2: i256) returns (i256);
function {:builtin "div"} $udiv.i1(i1: i1, i2: i1) returns (i1);
function {:builtin "div"} $udiv.i5(i1: i5, i2: i5) returns (i5);
function {:builtin "div"} $udiv.i6(i1: i6, i2: i6) returns (i6);
function {:builtin "div"} $udiv.i8(i1: i8, i2: i8) returns (i8);
function {:builtin "div"} $udiv.i16(i1: i16, i2: i16) returns (i16);
function {:builtin "div"} $udiv.i24(i1: i24, i2: i24) returns (i24);
function {:builtin "div"} $udiv.i32(i1: i32, i2: i32) returns (i32);
function {:builtin "div"} $udiv.i40(i1: i40, i2: i40) returns (i40);
function {:builtin "div"} $udiv.i48(i1: i48, i2: i48) returns (i48);
function {:builtin "div"} $udiv.i56(i1: i56, i2: i56) returns (i56);
function {:builtin "div"} $udiv.i64(i1: i64, i2: i64) returns (i64);
function {:builtin "div"} $udiv.i80(i1: i80, i2: i80) returns (i80);
function {:builtin "div"} $udiv.i88(i1: i88, i2: i88) returns (i88);
function {:builtin "div"} $udiv.i96(i1: i96, i2: i96) returns (i96);
function {:builtin "div"} $udiv.i128(i1: i128, i2: i128) returns (i128);
function {:builtin "div"} $udiv.i160(i1: i160, i2: i160) returns (i160);
function {:builtin "div"} $udiv.i256(i1: i256, i2: i256) returns (i256);
function {:define} $srem.i1(i1: i1, i2: i1) returns (i1) { (if ($ne.i1.bool($smod.i1(i1, i2), 0) && $slt.i1.bool(i1, 0)) then $sub.i1($smod.i1(i1, i2), $smax.i1(i2, $sub.i1(0, i2))) else $smod.i1(i1, i2)) }
function {:define} $srem.i5(i1: i5, i2: i5) returns (i5) { (if ($ne.i5.bool($smod.i5(i1, i2), 0) && $slt.i5.bool(i1, 0)) then $sub.i5($smod.i5(i1, i2), $smax.i5(i2, $sub.i5(0, i2))) else $smod.i5(i1, i2)) }
function {:define} $srem.i6(i1: i6, i2: i6) returns (i6) { (if ($ne.i6.bool($smod.i6(i1, i2), 0) && $slt.i6.bool(i1, 0)) then $sub.i6($smod.i6(i1, i2), $smax.i6(i2, $sub.i6(0, i2))) else $smod.i6(i1, i2)) }
function {:define} $srem.i8(i1: i8, i2: i8) returns (i8) { (if ($ne.i8.bool($smod.i8(i1, i2), 0) && $slt.i8.bool(i1, 0)) then $sub.i8($smod.i8(i1, i2), $smax.i8(i2, $sub.i8(0, i2))) else $smod.i8(i1, i2)) }
function {:define} $srem.i16(i1: i16, i2: i16) returns (i16) { (if ($ne.i16.bool($smod.i16(i1, i2), 0) && $slt.i16.bool(i1, 0)) then $sub.i16($smod.i16(i1, i2), $smax.i16(i2, $sub.i16(0, i2))) else $smod.i16(i1, i2)) }
function {:define} $srem.i24(i1: i24, i2: i24) returns (i24) { (if ($ne.i24.bool($smod.i24(i1, i2), 0) && $slt.i24.bool(i1, 0)) then $sub.i24($smod.i24(i1, i2), $smax.i24(i2, $sub.i24(0, i2))) else $smod.i24(i1, i2)) }
function {:define} $srem.i32(i1: i32, i2: i32) returns (i32) { (if ($ne.i32.bool($smod.i32(i1, i2), 0) && $slt.i32.bool(i1, 0)) then $sub.i32($smod.i32(i1, i2), $smax.i32(i2, $sub.i32(0, i2))) else $smod.i32(i1, i2)) }
function {:define} $srem.i40(i1: i40, i2: i40) returns (i40) { (if ($ne.i40.bool($smod.i40(i1, i2), 0) && $slt.i40.bool(i1, 0)) then $sub.i40($smod.i40(i1, i2), $smax.i40(i2, $sub.i40(0, i2))) else $smod.i40(i1, i2)) }
function {:define} $srem.i48(i1: i48, i2: i48) returns (i48) { (if ($ne.i48.bool($smod.i48(i1, i2), 0) && $slt.i48.bool(i1, 0)) then $sub.i48($smod.i48(i1, i2), $smax.i48(i2, $sub.i48(0, i2))) else $smod.i48(i1, i2)) }
function {:define} $srem.i56(i1: i56, i2: i56) returns (i56) { (if ($ne.i56.bool($smod.i56(i1, i2), 0) && $slt.i56.bool(i1, 0)) then $sub.i56($smod.i56(i1, i2), $smax.i56(i2, $sub.i56(0, i2))) else $smod.i56(i1, i2)) }
function {:define} $srem.i64(i1: i64, i2: i64) returns (i64) { (if ($ne.i64.bool($smod.i64(i1, i2), 0) && $slt.i64.bool(i1, 0)) then $sub.i64($smod.i64(i1, i2), $smax.i64(i2, $sub.i64(0, i2))) else $smod.i64(i1, i2)) }
function {:define} $srem.i80(i1: i80, i2: i80) returns (i80) { (if ($ne.i80.bool($smod.i80(i1, i2), 0) && $slt.i80.bool(i1, 0)) then $sub.i80($smod.i80(i1, i2), $smax.i80(i2, $sub.i80(0, i2))) else $smod.i80(i1, i2)) }
function {:define} $srem.i88(i1: i88, i2: i88) returns (i88) { (if ($ne.i88.bool($smod.i88(i1, i2), 0) && $slt.i88.bool(i1, 0)) then $sub.i88($smod.i88(i1, i2), $smax.i88(i2, $sub.i88(0, i2))) else $smod.i88(i1, i2)) }
function {:define} $srem.i96(i1: i96, i2: i96) returns (i96) { (if ($ne.i96.bool($smod.i96(i1, i2), 0) && $slt.i96.bool(i1, 0)) then $sub.i96($smod.i96(i1, i2), $smax.i96(i2, $sub.i96(0, i2))) else $smod.i96(i1, i2)) }
function {:define} $srem.i128(i1: i128, i2: i128) returns (i128) { (if ($ne.i128.bool($smod.i128(i1, i2), 0) && $slt.i128.bool(i1, 0)) then $sub.i128($smod.i128(i1, i2), $smax.i128(i2, $sub.i128(0, i2))) else $smod.i128(i1, i2)) }
function {:define} $srem.i160(i1: i160, i2: i160) returns (i160) { (if ($ne.i160.bool($smod.i160(i1, i2), 0) && $slt.i160.bool(i1, 0)) then $sub.i160($smod.i160(i1, i2), $smax.i160(i2, $sub.i160(0, i2))) else $smod.i160(i1, i2)) }
function {:define} $srem.i256(i1: i256, i2: i256) returns (i256) { (if ($ne.i256.bool($smod.i256(i1, i2), 0) && $slt.i256.bool(i1, 0)) then $sub.i256($smod.i256(i1, i2), $smax.i256(i2, $sub.i256(0, i2))) else $smod.i256(i1, i2)) }
function {:define} $urem.i1(i1: i1, i2: i1) returns (i1) { $smod.i1(i1, i2) }
function {:define} $urem.i5(i1: i5, i2: i5) returns (i5) { $smod.i5(i1, i2) }
function {:define} $urem.i6(i1: i6, i2: i6) returns (i6) { $smod.i6(i1, i2) }
function {:define} $urem.i8(i1: i8, i2: i8) returns (i8) { $smod.i8(i1, i2) }
function {:define} $urem.i16(i1: i16, i2: i16) returns (i16) { $smod.i16(i1, i2) }
function {:define} $urem.i24(i1: i24, i2: i24) returns (i24) { $smod.i24(i1, i2) }
function {:define} $urem.i32(i1: i32, i2: i32) returns (i32) { $smod.i32(i1, i2) }
function {:define} $urem.i40(i1: i40, i2: i40) returns (i40) { $smod.i40(i1, i2) }
function {:define} $urem.i48(i1: i48, i2: i48) returns (i48) { $smod.i48(i1, i2) }
function {:define} $urem.i56(i1: i56, i2: i56) returns (i56) { $smod.i56(i1, i2) }
function {:define} $urem.i64(i1: i64, i2: i64) returns (i64) { $smod.i64(i1, i2) }
function {:define} $urem.i80(i1: i80, i2: i80) returns (i80) { $smod.i80(i1, i2) }
function {:define} $urem.i88(i1: i88, i2: i88) returns (i88) { $smod.i88(i1, i2) }
function {:define} $urem.i96(i1: i96, i2: i96) returns (i96) { $smod.i96(i1, i2) }
function {:define} $urem.i128(i1: i128, i2: i128) returns (i128) { $smod.i128(i1, i2) }
function {:define} $urem.i160(i1: i160, i2: i160) returns (i160) { $smod.i160(i1, i2) }
function {:define} $urem.i256(i1: i256, i2: i256) returns (i256) { $smod.i256(i1, i2) }
function $shl.i1(i1: i1, i2: i1) returns (i1);
function $shl.i5(i1: i5, i2: i5) returns (i5);
function $shl.i6(i1: i6, i2: i6) returns (i6);
function $shl.i8(i1: i8, i2: i8) returns (i8);
function $shl.i16(i1: i16, i2: i16) returns (i16);
function $shl.i24(i1: i24, i2: i24) returns (i24);
function $shl.i32(i1: i32, i2: i32) returns (i32);
function $shl.i40(i1: i40, i2: i40) returns (i40);
function $shl.i48(i1: i48, i2: i48) returns (i48);
function $shl.i56(i1: i56, i2: i56) returns (i56);
function $shl.i64(i1: i64, i2: i64) returns (i64);
function $shl.i80(i1: i80, i2: i80) returns (i80);
function $shl.i88(i1: i88, i2: i88) returns (i88);
function $shl.i96(i1: i96, i2: i96) returns (i96);
function $shl.i128(i1: i128, i2: i128) returns (i128);
function $shl.i160(i1: i160, i2: i160) returns (i160);
function $shl.i256(i1: i256, i2: i256) returns (i256);
function $lshr.i1(i1: i1, i2: i1) returns (i1);
function $lshr.i5(i1: i5, i2: i5) returns (i5);
function $lshr.i6(i1: i6, i2: i6) returns (i6);
function $lshr.i8(i1: i8, i2: i8) returns (i8);
function $lshr.i16(i1: i16, i2: i16) returns (i16);
function $lshr.i24(i1: i24, i2: i24) returns (i24);
function $lshr.i32(i1: i32, i2: i32) returns (i32);
function $lshr.i40(i1: i40, i2: i40) returns (i40);
function $lshr.i48(i1: i48, i2: i48) returns (i48);
function $lshr.i56(i1: i56, i2: i56) returns (i56);
function $lshr.i64(i1: i64, i2: i64) returns (i64);
function $lshr.i80(i1: i80, i2: i80) returns (i80);
function $lshr.i88(i1: i88, i2: i88) returns (i88);
function $lshr.i96(i1: i96, i2: i96) returns (i96);
function $lshr.i128(i1: i128, i2: i128) returns (i128);
function $lshr.i160(i1: i160, i2: i160) returns (i160);
function $lshr.i256(i1: i256, i2: i256) returns (i256);
function $ashr.i1(i1: i1, i2: i1) returns (i1);
function $ashr.i5(i1: i5, i2: i5) returns (i5);
function $ashr.i6(i1: i6, i2: i6) returns (i6);
function $ashr.i8(i1: i8, i2: i8) returns (i8);
function $ashr.i16(i1: i16, i2: i16) returns (i16);
function $ashr.i24(i1: i24, i2: i24) returns (i24);
function $ashr.i32(i1: i32, i2: i32) returns (i32);
function $ashr.i40(i1: i40, i2: i40) returns (i40);
function $ashr.i48(i1: i48, i2: i48) returns (i48);
function $ashr.i56(i1: i56, i2: i56) returns (i56);
function $ashr.i64(i1: i64, i2: i64) returns (i64);
function $ashr.i80(i1: i80, i2: i80) returns (i80);
function $ashr.i88(i1: i88, i2: i88) returns (i88);
function $ashr.i96(i1: i96, i2: i96) returns (i96);
function $ashr.i128(i1: i128, i2: i128) returns (i128);
function $ashr.i160(i1: i160, i2: i160) returns (i160);
function $ashr.i256(i1: i256, i2: i256) returns (i256);
function $and.i1(i1: i1, i2: i1) returns (i1);
function $and.i5(i1: i5, i2: i5) returns (i5);
function $and.i6(i1: i6, i2: i6) returns (i6);
function $and.i8(i1: i8, i2: i8) returns (i8);
function $and.i16(i1: i16, i2: i16) returns (i16);
function $and.i24(i1: i24, i2: i24) returns (i24);
function $and.i32(i1: i32, i2: i32) returns (i32);
function $and.i40(i1: i40, i2: i40) returns (i40);
function $and.i48(i1: i48, i2: i48) returns (i48);
function $and.i56(i1: i56, i2: i56) returns (i56);
function $and.i64(i1: i64, i2: i64) returns (i64);
function $and.i80(i1: i80, i2: i80) returns (i80);
function $and.i88(i1: i88, i2: i88) returns (i88);
function $and.i96(i1: i96, i2: i96) returns (i96);
function $and.i128(i1: i128, i2: i128) returns (i128);
function $and.i160(i1: i160, i2: i160) returns (i160);
function $and.i256(i1: i256, i2: i256) returns (i256);
function $or.i1(i1: i1, i2: i1) returns (i1);
function $or.i5(i1: i5, i2: i5) returns (i5);
function $or.i6(i1: i6, i2: i6) returns (i6);
function $or.i8(i1: i8, i2: i8) returns (i8);
function $or.i16(i1: i16, i2: i16) returns (i16);
function $or.i24(i1: i24, i2: i24) returns (i24);
function $or.i32(i1: i32, i2: i32) returns (i32);
function $or.i40(i1: i40, i2: i40) returns (i40);
function $or.i48(i1: i48, i2: i48) returns (i48);
function $or.i56(i1: i56, i2: i56) returns (i56);
function $or.i64(i1: i64, i2: i64) returns (i64);
function $or.i80(i1: i80, i2: i80) returns (i80);
function $or.i88(i1: i88, i2: i88) returns (i88);
function $or.i96(i1: i96, i2: i96) returns (i96);
function $or.i128(i1: i128, i2: i128) returns (i128);
function $or.i160(i1: i160, i2: i160) returns (i160);
function $or.i256(i1: i256, i2: i256) returns (i256);
function $xor.i1(i1: i1, i2: i1) returns (i1);
function $xor.i5(i1: i5, i2: i5) returns (i5);
function $xor.i6(i1: i6, i2: i6) returns (i6);
function $xor.i8(i1: i8, i2: i8) returns (i8);
function $xor.i16(i1: i16, i2: i16) returns (i16);
function $xor.i24(i1: i24, i2: i24) returns (i24);
function $xor.i32(i1: i32, i2: i32) returns (i32);
function $xor.i40(i1: i40, i2: i40) returns (i40);
function $xor.i48(i1: i48, i2: i48) returns (i48);
function $xor.i56(i1: i56, i2: i56) returns (i56);
function $xor.i64(i1: i64, i2: i64) returns (i64);
function $xor.i80(i1: i80, i2: i80) returns (i80);
function $xor.i88(i1: i88, i2: i88) returns (i88);
function $xor.i96(i1: i96, i2: i96) returns (i96);
function $xor.i128(i1: i128, i2: i128) returns (i128);
function $xor.i160(i1: i160, i2: i160) returns (i160);
function $xor.i256(i1: i256, i2: i256) returns (i256);
function $nand.i1(i1: i1, i2: i1) returns (i1);
function $nand.i5(i1: i5, i2: i5) returns (i5);
function $nand.i6(i1: i6, i2: i6) returns (i6);
function $nand.i8(i1: i8, i2: i8) returns (i8);
function $nand.i16(i1: i16, i2: i16) returns (i16);
function $nand.i24(i1: i24, i2: i24) returns (i24);
function $nand.i32(i1: i32, i2: i32) returns (i32);
function $nand.i40(i1: i40, i2: i40) returns (i40);
function $nand.i48(i1: i48, i2: i48) returns (i48);
function $nand.i56(i1: i56, i2: i56) returns (i56);
function $nand.i64(i1: i64, i2: i64) returns (i64);
function $nand.i80(i1: i80, i2: i80) returns (i80);
function $nand.i88(i1: i88, i2: i88) returns (i88);
function $nand.i96(i1: i96, i2: i96) returns (i96);
function $nand.i128(i1: i128, i2: i128) returns (i128);
function $nand.i160(i1: i160, i2: i160) returns (i160);
function $nand.i256(i1: i256, i2: i256) returns (i256);
function $not.i1(i: i1) returns (i1);
function $not.i5(i: i5) returns (i5);
function $not.i6(i: i6) returns (i6);
function $not.i8(i: i8) returns (i8);
function $not.i16(i: i16) returns (i16);
function $not.i24(i: i24) returns (i24);
function $not.i32(i: i32) returns (i32);
function $not.i40(i: i40) returns (i40);
function $not.i48(i: i48) returns (i48);
function $not.i56(i: i56) returns (i56);
function $not.i64(i: i64) returns (i64);
function $not.i80(i: i80) returns (i80);
function $not.i88(i: i88) returns (i88);
function $not.i96(i: i96) returns (i96);
function $not.i128(i: i128) returns (i128);
function $not.i160(i: i160) returns (i160);
function $not.i256(i: i256) returns (i256);
function {:define} $smin.i1(i1: i1, i2: i1) returns (i1) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i5(i1: i5, i2: i5) returns (i5) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i6(i1: i6, i2: i6) returns (i6) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i8(i1: i8, i2: i8) returns (i8) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i16(i1: i16, i2: i16) returns (i16) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i24(i1: i24, i2: i24) returns (i24) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i32(i1: i32, i2: i32) returns (i32) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i40(i1: i40, i2: i40) returns (i40) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i48(i1: i48, i2: i48) returns (i48) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i56(i1: i56, i2: i56) returns (i56) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i64(i1: i64, i2: i64) returns (i64) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i80(i1: i80, i2: i80) returns (i80) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i88(i1: i88, i2: i88) returns (i88) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i96(i1: i96, i2: i96) returns (i96) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i128(i1: i128, i2: i128) returns (i128) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i160(i1: i160, i2: i160) returns (i160) { (if (i1 < i2) then i1 else i2) }
function {:define} $smin.i256(i1: i256, i2: i256) returns (i256) { (if (i1 < i2) then i1 else i2) }
function {:define} $smax.i1(i1: i1, i2: i1) returns (i1) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i5(i1: i5, i2: i5) returns (i5) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i6(i1: i6, i2: i6) returns (i6) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i8(i1: i8, i2: i8) returns (i8) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i16(i1: i16, i2: i16) returns (i16) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i24(i1: i24, i2: i24) returns (i24) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i32(i1: i32, i2: i32) returns (i32) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i40(i1: i40, i2: i40) returns (i40) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i48(i1: i48, i2: i48) returns (i48) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i56(i1: i56, i2: i56) returns (i56) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i64(i1: i64, i2: i64) returns (i64) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i80(i1: i80, i2: i80) returns (i80) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i88(i1: i88, i2: i88) returns (i88) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i96(i1: i96, i2: i96) returns (i96) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i128(i1: i128, i2: i128) returns (i128) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i160(i1: i160, i2: i160) returns (i160) { (if (i2 < i1) then i1 else i2) }
function {:define} $smax.i256(i1: i256, i2: i256) returns (i256) { (if (i2 < i1) then i1 else i2) }
function {:define} $umin.i1(i1: i1, i2: i1) returns (i1) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i5(i1: i5, i2: i5) returns (i5) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i6(i1: i6, i2: i6) returns (i6) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i8(i1: i8, i2: i8) returns (i8) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i16(i1: i16, i2: i16) returns (i16) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i24(i1: i24, i2: i24) returns (i24) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i32(i1: i32, i2: i32) returns (i32) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i40(i1: i40, i2: i40) returns (i40) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i48(i1: i48, i2: i48) returns (i48) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i56(i1: i56, i2: i56) returns (i56) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i64(i1: i64, i2: i64) returns (i64) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i80(i1: i80, i2: i80) returns (i80) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i88(i1: i88, i2: i88) returns (i88) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i96(i1: i96, i2: i96) returns (i96) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i128(i1: i128, i2: i128) returns (i128) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i160(i1: i160, i2: i160) returns (i160) { (if (i1 < i2) then i1 else i2) }
function {:define} $umin.i256(i1: i256, i2: i256) returns (i256) { (if (i1 < i2) then i1 else i2) }
function {:define} $umax.i1(i1: i1, i2: i1) returns (i1) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i5(i1: i5, i2: i5) returns (i5) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i6(i1: i6, i2: i6) returns (i6) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i8(i1: i8, i2: i8) returns (i8) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i16(i1: i16, i2: i16) returns (i16) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i24(i1: i24, i2: i24) returns (i24) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i32(i1: i32, i2: i32) returns (i32) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i40(i1: i40, i2: i40) returns (i40) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i48(i1: i48, i2: i48) returns (i48) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i56(i1: i56, i2: i56) returns (i56) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i64(i1: i64, i2: i64) returns (i64) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i80(i1: i80, i2: i80) returns (i80) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i88(i1: i88, i2: i88) returns (i88) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i96(i1: i96, i2: i96) returns (i96) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i128(i1: i128, i2: i128) returns (i128) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i160(i1: i160, i2: i160) returns (i160) { (if (i2 < i1) then i1 else i2) }
function {:define} $umax.i256(i1: i256, i2: i256) returns (i256) { (if (i2 < i1) then i1 else i2) }
axiom ($and.i1(0, 0) == 0);
axiom ($or.i1(0, 0) == 0);
axiom ($xor.i1(0, 0) == 0);
axiom ($and.i1(0, 1) == 0);
axiom ($or.i1(0, 1) == 1);
axiom ($xor.i1(0, 1) == 1);
axiom ($and.i1(1, 0) == 0);
axiom ($or.i1(1, 0) == 1);
axiom ($xor.i1(1, 0) == 1);
axiom ($and.i1(1, 1) == 1);
axiom ($or.i1(1, 1) == 1);
axiom ($xor.i1(1, 1) == 0);
axiom ($and.i32(32, 16) == 0);
// Integer predicates
function {:define} $ule.i1.bool(i1: i1, i2: i1) returns (bool) { (i1 <= i2) }
function {:define} $ule.i1(i1: i1, i2: i1) returns (i1) { (if $ule.i1.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i5.bool(i1: i5, i2: i5) returns (bool) { (i1 <= i2) }
function {:define} $ule.i5(i1: i5, i2: i5) returns (i1) { (if $ule.i5.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i6.bool(i1: i6, i2: i6) returns (bool) { (i1 <= i2) }
function {:define} $ule.i6(i1: i6, i2: i6) returns (i1) { (if $ule.i6.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i8.bool(i1: i8, i2: i8) returns (bool) { (i1 <= i2) }
function {:define} $ule.i8(i1: i8, i2: i8) returns (i1) { (if $ule.i8.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i16.bool(i1: i16, i2: i16) returns (bool) { (i1 <= i2) }
function {:define} $ule.i16(i1: i16, i2: i16) returns (i1) { (if $ule.i16.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i24.bool(i1: i24, i2: i24) returns (bool) { (i1 <= i2) }
function {:define} $ule.i24(i1: i24, i2: i24) returns (i1) { (if $ule.i24.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i32.bool(i1: i32, i2: i32) returns (bool) { (i1 <= i2) }
function {:define} $ule.i32(i1: i32, i2: i32) returns (i1) { (if $ule.i32.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i40.bool(i1: i40, i2: i40) returns (bool) { (i1 <= i2) }
function {:define} $ule.i40(i1: i40, i2: i40) returns (i1) { (if $ule.i40.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i48.bool(i1: i48, i2: i48) returns (bool) { (i1 <= i2) }
function {:define} $ule.i48(i1: i48, i2: i48) returns (i1) { (if $ule.i48.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i56.bool(i1: i56, i2: i56) returns (bool) { (i1 <= i2) }
function {:define} $ule.i56(i1: i56, i2: i56) returns (i1) { (if $ule.i56.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i64.bool(i1: i64, i2: i64) returns (bool) { (i1 <= i2) }
function {:define} $ule.i64(i1: i64, i2: i64) returns (i1) { (if $ule.i64.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i80.bool(i1: i80, i2: i80) returns (bool) { (i1 <= i2) }
function {:define} $ule.i80(i1: i80, i2: i80) returns (i1) { (if $ule.i80.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i88.bool(i1: i88, i2: i88) returns (bool) { (i1 <= i2) }
function {:define} $ule.i88(i1: i88, i2: i88) returns (i1) { (if $ule.i88.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i96.bool(i1: i96, i2: i96) returns (bool) { (i1 <= i2) }
function {:define} $ule.i96(i1: i96, i2: i96) returns (i1) { (if $ule.i96.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i128.bool(i1: i128, i2: i128) returns (bool) { (i1 <= i2) }
function {:define} $ule.i128(i1: i128, i2: i128) returns (i1) { (if $ule.i128.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i160.bool(i1: i160, i2: i160) returns (bool) { (i1 <= i2) }
function {:define} $ule.i160(i1: i160, i2: i160) returns (i1) { (if $ule.i160.bool(i1, i2) then 1 else 0) }
function {:define} $ule.i256.bool(i1: i256, i2: i256) returns (bool) { (i1 <= i2) }
function {:define} $ule.i256(i1: i256, i2: i256) returns (i1) { (if $ule.i256.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i1.bool(i1: i1, i2: i1) returns (bool) { (i1 < i2) }
function {:define} $ult.i1(i1: i1, i2: i1) returns (i1) { (if $ult.i1.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i5.bool(i1: i5, i2: i5) returns (bool) { (i1 < i2) }
function {:define} $ult.i5(i1: i5, i2: i5) returns (i1) { (if $ult.i5.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i6.bool(i1: i6, i2: i6) returns (bool) { (i1 < i2) }
function {:define} $ult.i6(i1: i6, i2: i6) returns (i1) { (if $ult.i6.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i8.bool(i1: i8, i2: i8) returns (bool) { (i1 < i2) }
function {:define} $ult.i8(i1: i8, i2: i8) returns (i1) { (if $ult.i8.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i16.bool(i1: i16, i2: i16) returns (bool) { (i1 < i2) }
function {:define} $ult.i16(i1: i16, i2: i16) returns (i1) { (if $ult.i16.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i24.bool(i1: i24, i2: i24) returns (bool) { (i1 < i2) }
function {:define} $ult.i24(i1: i24, i2: i24) returns (i1) { (if $ult.i24.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i32.bool(i1: i32, i2: i32) returns (bool) { (i1 < i2) }
function {:define} $ult.i32(i1: i32, i2: i32) returns (i1) { (if $ult.i32.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i40.bool(i1: i40, i2: i40) returns (bool) { (i1 < i2) }
function {:define} $ult.i40(i1: i40, i2: i40) returns (i1) { (if $ult.i40.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i48.bool(i1: i48, i2: i48) returns (bool) { (i1 < i2) }
function {:define} $ult.i48(i1: i48, i2: i48) returns (i1) { (if $ult.i48.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i56.bool(i1: i56, i2: i56) returns (bool) { (i1 < i2) }
function {:define} $ult.i56(i1: i56, i2: i56) returns (i1) { (if $ult.i56.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i64.bool(i1: i64, i2: i64) returns (bool) { (i1 < i2) }
function {:define} $ult.i64(i1: i64, i2: i64) returns (i1) { (if $ult.i64.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i80.bool(i1: i80, i2: i80) returns (bool) { (i1 < i2) }
function {:define} $ult.i80(i1: i80, i2: i80) returns (i1) { (if $ult.i80.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i88.bool(i1: i88, i2: i88) returns (bool) { (i1 < i2) }
function {:define} $ult.i88(i1: i88, i2: i88) returns (i1) { (if $ult.i88.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i96.bool(i1: i96, i2: i96) returns (bool) { (i1 < i2) }
function {:define} $ult.i96(i1: i96, i2: i96) returns (i1) { (if $ult.i96.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i128.bool(i1: i128, i2: i128) returns (bool) { (i1 < i2) }
function {:define} $ult.i128(i1: i128, i2: i128) returns (i1) { (if $ult.i128.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i160.bool(i1: i160, i2: i160) returns (bool) { (i1 < i2) }
function {:define} $ult.i160(i1: i160, i2: i160) returns (i1) { (if $ult.i160.bool(i1, i2) then 1 else 0) }
function {:define} $ult.i256.bool(i1: i256, i2: i256) returns (bool) { (i1 < i2) }
function {:define} $ult.i256(i1: i256, i2: i256) returns (i1) { (if $ult.i256.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i1.bool(i1: i1, i2: i1) returns (bool) { (i1 >= i2) }
function {:define} $uge.i1(i1: i1, i2: i1) returns (i1) { (if $uge.i1.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i5.bool(i1: i5, i2: i5) returns (bool) { (i1 >= i2) }
function {:define} $uge.i5(i1: i5, i2: i5) returns (i1) { (if $uge.i5.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i6.bool(i1: i6, i2: i6) returns (bool) { (i1 >= i2) }
function {:define} $uge.i6(i1: i6, i2: i6) returns (i1) { (if $uge.i6.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i8.bool(i1: i8, i2: i8) returns (bool) { (i1 >= i2) }
function {:define} $uge.i8(i1: i8, i2: i8) returns (i1) { (if $uge.i8.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i16.bool(i1: i16, i2: i16) returns (bool) { (i1 >= i2) }
function {:define} $uge.i16(i1: i16, i2: i16) returns (i1) { (if $uge.i16.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i24.bool(i1: i24, i2: i24) returns (bool) { (i1 >= i2) }
function {:define} $uge.i24(i1: i24, i2: i24) returns (i1) { (if $uge.i24.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i32.bool(i1: i32, i2: i32) returns (bool) { (i1 >= i2) }
function {:define} $uge.i32(i1: i32, i2: i32) returns (i1) { (if $uge.i32.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i40.bool(i1: i40, i2: i40) returns (bool) { (i1 >= i2) }
function {:define} $uge.i40(i1: i40, i2: i40) returns (i1) { (if $uge.i40.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i48.bool(i1: i48, i2: i48) returns (bool) { (i1 >= i2) }
function {:define} $uge.i48(i1: i48, i2: i48) returns (i1) { (if $uge.i48.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i56.bool(i1: i56, i2: i56) returns (bool) { (i1 >= i2) }
function {:define} $uge.i56(i1: i56, i2: i56) returns (i1) { (if $uge.i56.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i64.bool(i1: i64, i2: i64) returns (bool) { (i1 >= i2) }
function {:define} $uge.i64(i1: i64, i2: i64) returns (i1) { (if $uge.i64.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i80.bool(i1: i80, i2: i80) returns (bool) { (i1 >= i2) }
function {:define} $uge.i80(i1: i80, i2: i80) returns (i1) { (if $uge.i80.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i88.bool(i1: i88, i2: i88) returns (bool) { (i1 >= i2) }
function {:define} $uge.i88(i1: i88, i2: i88) returns (i1) { (if $uge.i88.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i96.bool(i1: i96, i2: i96) returns (bool) { (i1 >= i2) }
function {:define} $uge.i96(i1: i96, i2: i96) returns (i1) { (if $uge.i96.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i128.bool(i1: i128, i2: i128) returns (bool) { (i1 >= i2) }
function {:define} $uge.i128(i1: i128, i2: i128) returns (i1) { (if $uge.i128.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i160.bool(i1: i160, i2: i160) returns (bool) { (i1 >= i2) }
function {:define} $uge.i160(i1: i160, i2: i160) returns (i1) { (if $uge.i160.bool(i1, i2) then 1 else 0) }
function {:define} $uge.i256.bool(i1: i256, i2: i256) returns (bool) { (i1 >= i2) }
function {:define} $uge.i256(i1: i256, i2: i256) returns (i1) { (if $uge.i256.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i1.bool(i1: i1, i2: i1) returns (bool) { (i1 > i2) }
function {:define} $ugt.i1(i1: i1, i2: i1) returns (i1) { (if $ugt.i1.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i5.bool(i1: i5, i2: i5) returns (bool) { (i1 > i2) }
function {:define} $ugt.i5(i1: i5, i2: i5) returns (i1) { (if $ugt.i5.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i6.bool(i1: i6, i2: i6) returns (bool) { (i1 > i2) }
function {:define} $ugt.i6(i1: i6, i2: i6) returns (i1) { (if $ugt.i6.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i8.bool(i1: i8, i2: i8) returns (bool) { (i1 > i2) }
function {:define} $ugt.i8(i1: i8, i2: i8) returns (i1) { (if $ugt.i8.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i16.bool(i1: i16, i2: i16) returns (bool) { (i1 > i2) }
function {:define} $ugt.i16(i1: i16, i2: i16) returns (i1) { (if $ugt.i16.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i24.bool(i1: i24, i2: i24) returns (bool) { (i1 > i2) }
function {:define} $ugt.i24(i1: i24, i2: i24) returns (i1) { (if $ugt.i24.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i32.bool(i1: i32, i2: i32) returns (bool) { (i1 > i2) }
function {:define} $ugt.i32(i1: i32, i2: i32) returns (i1) { (if $ugt.i32.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i40.bool(i1: i40, i2: i40) returns (bool) { (i1 > i2) }
function {:define} $ugt.i40(i1: i40, i2: i40) returns (i1) { (if $ugt.i40.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i48.bool(i1: i48, i2: i48) returns (bool) { (i1 > i2) }
function {:define} $ugt.i48(i1: i48, i2: i48) returns (i1) { (if $ugt.i48.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i56.bool(i1: i56, i2: i56) returns (bool) { (i1 > i2) }
function {:define} $ugt.i56(i1: i56, i2: i56) returns (i1) { (if $ugt.i56.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i64.bool(i1: i64, i2: i64) returns (bool) { (i1 > i2) }
function {:define} $ugt.i64(i1: i64, i2: i64) returns (i1) { (if $ugt.i64.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i80.bool(i1: i80, i2: i80) returns (bool) { (i1 > i2) }
function {:define} $ugt.i80(i1: i80, i2: i80) returns (i1) { (if $ugt.i80.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i88.bool(i1: i88, i2: i88) returns (bool) { (i1 > i2) }
function {:define} $ugt.i88(i1: i88, i2: i88) returns (i1) { (if $ugt.i88.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i96.bool(i1: i96, i2: i96) returns (bool) { (i1 > i2) }
function {:define} $ugt.i96(i1: i96, i2: i96) returns (i1) { (if $ugt.i96.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i128.bool(i1: i128, i2: i128) returns (bool) { (i1 > i2) }
function {:define} $ugt.i128(i1: i128, i2: i128) returns (i1) { (if $ugt.i128.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i160.bool(i1: i160, i2: i160) returns (bool) { (i1 > i2) }
function {:define} $ugt.i160(i1: i160, i2: i160) returns (i1) { (if $ugt.i160.bool(i1, i2) then 1 else 0) }
function {:define} $ugt.i256.bool(i1: i256, i2: i256) returns (bool) { (i1 > i2) }
function {:define} $ugt.i256(i1: i256, i2: i256) returns (i1) { (if $ugt.i256.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i1.bool(i1: i1, i2: i1) returns (bool) { (i1 <= i2) }
function {:define} $sle.i1(i1: i1, i2: i1) returns (i1) { (if $sle.i1.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i5.bool(i1: i5, i2: i5) returns (bool) { (i1 <= i2) }
function {:define} $sle.i5(i1: i5, i2: i5) returns (i1) { (if $sle.i5.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i6.bool(i1: i6, i2: i6) returns (bool) { (i1 <= i2) }
function {:define} $sle.i6(i1: i6, i2: i6) returns (i1) { (if $sle.i6.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i8.bool(i1: i8, i2: i8) returns (bool) { (i1 <= i2) }
function {:define} $sle.i8(i1: i8, i2: i8) returns (i1) { (if $sle.i8.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i16.bool(i1: i16, i2: i16) returns (bool) { (i1 <= i2) }
function {:define} $sle.i16(i1: i16, i2: i16) returns (i1) { (if $sle.i16.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i24.bool(i1: i24, i2: i24) returns (bool) { (i1 <= i2) }
function {:define} $sle.i24(i1: i24, i2: i24) returns (i1) { (if $sle.i24.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i32.bool(i1: i32, i2: i32) returns (bool) { (i1 <= i2) }
function {:define} $sle.i32(i1: i32, i2: i32) returns (i1) { (if $sle.i32.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i40.bool(i1: i40, i2: i40) returns (bool) { (i1 <= i2) }
function {:define} $sle.i40(i1: i40, i2: i40) returns (i1) { (if $sle.i40.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i48.bool(i1: i48, i2: i48) returns (bool) { (i1 <= i2) }
function {:define} $sle.i48(i1: i48, i2: i48) returns (i1) { (if $sle.i48.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i56.bool(i1: i56, i2: i56) returns (bool) { (i1 <= i2) }
function {:define} $sle.i56(i1: i56, i2: i56) returns (i1) { (if $sle.i56.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i64.bool(i1: i64, i2: i64) returns (bool) { (i1 <= i2) }
function {:define} $sle.i64(i1: i64, i2: i64) returns (i1) { (if $sle.i64.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i80.bool(i1: i80, i2: i80) returns (bool) { (i1 <= i2) }
function {:define} $sle.i80(i1: i80, i2: i80) returns (i1) { (if $sle.i80.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i88.bool(i1: i88, i2: i88) returns (bool) { (i1 <= i2) }
function {:define} $sle.i88(i1: i88, i2: i88) returns (i1) { (if $sle.i88.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i96.bool(i1: i96, i2: i96) returns (bool) { (i1 <= i2) }
function {:define} $sle.i96(i1: i96, i2: i96) returns (i1) { (if $sle.i96.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i128.bool(i1: i128, i2: i128) returns (bool) { (i1 <= i2) }
function {:define} $sle.i128(i1: i128, i2: i128) returns (i1) { (if $sle.i128.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i160.bool(i1: i160, i2: i160) returns (bool) { (i1 <= i2) }
function {:define} $sle.i160(i1: i160, i2: i160) returns (i1) { (if $sle.i160.bool(i1, i2) then 1 else 0) }
function {:define} $sle.i256.bool(i1: i256, i2: i256) returns (bool) { (i1 <= i2) }
function {:define} $sle.i256(i1: i256, i2: i256) returns (i1) { (if $sle.i256.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i1.bool(i1: i1, i2: i1) returns (bool) { (i1 < i2) }
function {:define} $slt.i1(i1: i1, i2: i1) returns (i1) { (if $slt.i1.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i5.bool(i1: i5, i2: i5) returns (bool) { (i1 < i2) }
function {:define} $slt.i5(i1: i5, i2: i5) returns (i1) { (if $slt.i5.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i6.bool(i1: i6, i2: i6) returns (bool) { (i1 < i2) }
function {:define} $slt.i6(i1: i6, i2: i6) returns (i1) { (if $slt.i6.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i8.bool(i1: i8, i2: i8) returns (bool) { (i1 < i2) }
function {:define} $slt.i8(i1: i8, i2: i8) returns (i1) { (if $slt.i8.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i16.bool(i1: i16, i2: i16) returns (bool) { (i1 < i2) }
function {:define} $slt.i16(i1: i16, i2: i16) returns (i1) { (if $slt.i16.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i24.bool(i1: i24, i2: i24) returns (bool) { (i1 < i2) }
function {:define} $slt.i24(i1: i24, i2: i24) returns (i1) { (if $slt.i24.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i32.bool(i1: i32, i2: i32) returns (bool) { (i1 < i2) }
function {:define} $slt.i32(i1: i32, i2: i32) returns (i1) { (if $slt.i32.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i40.bool(i1: i40, i2: i40) returns (bool) { (i1 < i2) }
function {:define} $slt.i40(i1: i40, i2: i40) returns (i1) { (if $slt.i40.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i48.bool(i1: i48, i2: i48) returns (bool) { (i1 < i2) }
function {:define} $slt.i48(i1: i48, i2: i48) returns (i1) { (if $slt.i48.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i56.bool(i1: i56, i2: i56) returns (bool) { (i1 < i2) }
function {:define} $slt.i56(i1: i56, i2: i56) returns (i1) { (if $slt.i56.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i64.bool(i1: i64, i2: i64) returns (bool) { (i1 < i2) }
function {:define} $slt.i64(i1: i64, i2: i64) returns (i1) { (if $slt.i64.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i80.bool(i1: i80, i2: i80) returns (bool) { (i1 < i2) }
function {:define} $slt.i80(i1: i80, i2: i80) returns (i1) { (if $slt.i80.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i88.bool(i1: i88, i2: i88) returns (bool) { (i1 < i2) }
function {:define} $slt.i88(i1: i88, i2: i88) returns (i1) { (if $slt.i88.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i96.bool(i1: i96, i2: i96) returns (bool) { (i1 < i2) }
function {:define} $slt.i96(i1: i96, i2: i96) returns (i1) { (if $slt.i96.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i128.bool(i1: i128, i2: i128) returns (bool) { (i1 < i2) }
function {:define} $slt.i128(i1: i128, i2: i128) returns (i1) { (if $slt.i128.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i160.bool(i1: i160, i2: i160) returns (bool) { (i1 < i2) }
function {:define} $slt.i160(i1: i160, i2: i160) returns (i1) { (if $slt.i160.bool(i1, i2) then 1 else 0) }
function {:define} $slt.i256.bool(i1: i256, i2: i256) returns (bool) { (i1 < i2) }
function {:define} $slt.i256(i1: i256, i2: i256) returns (i1) { (if $slt.i256.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i1.bool(i1: i1, i2: i1) returns (bool) { (i1 >= i2) }
function {:define} $sge.i1(i1: i1, i2: i1) returns (i1) { (if $sge.i1.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i5.bool(i1: i5, i2: i5) returns (bool) { (i1 >= i2) }
function {:define} $sge.i5(i1: i5, i2: i5) returns (i1) { (if $sge.i5.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i6.bool(i1: i6, i2: i6) returns (bool) { (i1 >= i2) }
function {:define} $sge.i6(i1: i6, i2: i6) returns (i1) { (if $sge.i6.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i8.bool(i1: i8, i2: i8) returns (bool) { (i1 >= i2) }
function {:define} $sge.i8(i1: i8, i2: i8) returns (i1) { (if $sge.i8.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i16.bool(i1: i16, i2: i16) returns (bool) { (i1 >= i2) }
function {:define} $sge.i16(i1: i16, i2: i16) returns (i1) { (if $sge.i16.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i24.bool(i1: i24, i2: i24) returns (bool) { (i1 >= i2) }
function {:define} $sge.i24(i1: i24, i2: i24) returns (i1) { (if $sge.i24.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i32.bool(i1: i32, i2: i32) returns (bool) { (i1 >= i2) }
function {:define} $sge.i32(i1: i32, i2: i32) returns (i1) { (if $sge.i32.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i40.bool(i1: i40, i2: i40) returns (bool) { (i1 >= i2) }
function {:define} $sge.i40(i1: i40, i2: i40) returns (i1) { (if $sge.i40.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i48.bool(i1: i48, i2: i48) returns (bool) { (i1 >= i2) }
function {:define} $sge.i48(i1: i48, i2: i48) returns (i1) { (if $sge.i48.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i56.bool(i1: i56, i2: i56) returns (bool) { (i1 >= i2) }
function {:define} $sge.i56(i1: i56, i2: i56) returns (i1) { (if $sge.i56.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i64.bool(i1: i64, i2: i64) returns (bool) { (i1 >= i2) }
function {:define} $sge.i64(i1: i64, i2: i64) returns (i1) { (if $sge.i64.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i80.bool(i1: i80, i2: i80) returns (bool) { (i1 >= i2) }
function {:define} $sge.i80(i1: i80, i2: i80) returns (i1) { (if $sge.i80.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i88.bool(i1: i88, i2: i88) returns (bool) { (i1 >= i2) }
function {:define} $sge.i88(i1: i88, i2: i88) returns (i1) { (if $sge.i88.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i96.bool(i1: i96, i2: i96) returns (bool) { (i1 >= i2) }
function {:define} $sge.i96(i1: i96, i2: i96) returns (i1) { (if $sge.i96.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i128.bool(i1: i128, i2: i128) returns (bool) { (i1 >= i2) }
function {:define} $sge.i128(i1: i128, i2: i128) returns (i1) { (if $sge.i128.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i160.bool(i1: i160, i2: i160) returns (bool) { (i1 >= i2) }
function {:define} $sge.i160(i1: i160, i2: i160) returns (i1) { (if $sge.i160.bool(i1, i2) then 1 else 0) }
function {:define} $sge.i256.bool(i1: i256, i2: i256) returns (bool) { (i1 >= i2) }
function {:define} $sge.i256(i1: i256, i2: i256) returns (i1) { (if $sge.i256.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i1.bool(i1: i1, i2: i1) returns (bool) { (i1 > i2) }
function {:define} $sgt.i1(i1: i1, i2: i1) returns (i1) { (if $sgt.i1.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i5.bool(i1: i5, i2: i5) returns (bool) { (i1 > i2) }
function {:define} $sgt.i5(i1: i5, i2: i5) returns (i1) { (if $sgt.i5.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i6.bool(i1: i6, i2: i6) returns (bool) { (i1 > i2) }
function {:define} $sgt.i6(i1: i6, i2: i6) returns (i1) { (if $sgt.i6.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i8.bool(i1: i8, i2: i8) returns (bool) { (i1 > i2) }
function {:define} $sgt.i8(i1: i8, i2: i8) returns (i1) { (if $sgt.i8.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i16.bool(i1: i16, i2: i16) returns (bool) { (i1 > i2) }
function {:define} $sgt.i16(i1: i16, i2: i16) returns (i1) { (if $sgt.i16.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i24.bool(i1: i24, i2: i24) returns (bool) { (i1 > i2) }
function {:define} $sgt.i24(i1: i24, i2: i24) returns (i1) { (if $sgt.i24.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i32.bool(i1: i32, i2: i32) returns (bool) { (i1 > i2) }
function {:define} $sgt.i32(i1: i32, i2: i32) returns (i1) { (if $sgt.i32.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i40.bool(i1: i40, i2: i40) returns (bool) { (i1 > i2) }
function {:define} $sgt.i40(i1: i40, i2: i40) returns (i1) { (if $sgt.i40.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i48.bool(i1: i48, i2: i48) returns (bool) { (i1 > i2) }
function {:define} $sgt.i48(i1: i48, i2: i48) returns (i1) { (if $sgt.i48.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i56.bool(i1: i56, i2: i56) returns (bool) { (i1 > i2) }
function {:define} $sgt.i56(i1: i56, i2: i56) returns (i1) { (if $sgt.i56.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i64.bool(i1: i64, i2: i64) returns (bool) { (i1 > i2) }
function {:define} $sgt.i64(i1: i64, i2: i64) returns (i1) { (if $sgt.i64.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i80.bool(i1: i80, i2: i80) returns (bool) { (i1 > i2) }
function {:define} $sgt.i80(i1: i80, i2: i80) returns (i1) { (if $sgt.i80.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i88.bool(i1: i88, i2: i88) returns (bool) { (i1 > i2) }
function {:define} $sgt.i88(i1: i88, i2: i88) returns (i1) { (if $sgt.i88.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i96.bool(i1: i96, i2: i96) returns (bool) { (i1 > i2) }
function {:define} $sgt.i96(i1: i96, i2: i96) returns (i1) { (if $sgt.i96.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i128.bool(i1: i128, i2: i128) returns (bool) { (i1 > i2) }
function {:define} $sgt.i128(i1: i128, i2: i128) returns (i1) { (if $sgt.i128.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i160.bool(i1: i160, i2: i160) returns (bool) { (i1 > i2) }
function {:define} $sgt.i160(i1: i160, i2: i160) returns (i1) { (if $sgt.i160.bool(i1, i2) then 1 else 0) }
function {:define} $sgt.i256.bool(i1: i256, i2: i256) returns (bool) { (i1 > i2) }
function {:define} $sgt.i256(i1: i256, i2: i256) returns (i1) { (if $sgt.i256.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i1.bool(i1: i1, i2: i1) returns (bool) { (i1 == i2) }
function {:define} $eq.i1(i1: i1, i2: i1) returns (i1) { (if $eq.i1.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i5.bool(i1: i5, i2: i5) returns (bool) { (i1 == i2) }
function {:define} $eq.i5(i1: i5, i2: i5) returns (i1) { (if $eq.i5.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i6.bool(i1: i6, i2: i6) returns (bool) { (i1 == i2) }
function {:define} $eq.i6(i1: i6, i2: i6) returns (i1) { (if $eq.i6.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i8.bool(i1: i8, i2: i8) returns (bool) { (i1 == i2) }
function {:define} $eq.i8(i1: i8, i2: i8) returns (i1) { (if $eq.i8.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i16.bool(i1: i16, i2: i16) returns (bool) { (i1 == i2) }
function {:define} $eq.i16(i1: i16, i2: i16) returns (i1) { (if $eq.i16.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i24.bool(i1: i24, i2: i24) returns (bool) { (i1 == i2) }
function {:define} $eq.i24(i1: i24, i2: i24) returns (i1) { (if $eq.i24.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i32.bool(i1: i32, i2: i32) returns (bool) { (i1 == i2) }
function {:define} $eq.i32(i1: i32, i2: i32) returns (i1) { (if $eq.i32.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i40.bool(i1: i40, i2: i40) returns (bool) { (i1 == i2) }
function {:define} $eq.i40(i1: i40, i2: i40) returns (i1) { (if $eq.i40.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i48.bool(i1: i48, i2: i48) returns (bool) { (i1 == i2) }
function {:define} $eq.i48(i1: i48, i2: i48) returns (i1) { (if $eq.i48.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i56.bool(i1: i56, i2: i56) returns (bool) { (i1 == i2) }
function {:define} $eq.i56(i1: i56, i2: i56) returns (i1) { (if $eq.i56.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i64.bool(i1: i64, i2: i64) returns (bool) { (i1 == i2) }
function {:define} $eq.i64(i1: i64, i2: i64) returns (i1) { (if $eq.i64.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i80.bool(i1: i80, i2: i80) returns (bool) { (i1 == i2) }
function {:define} $eq.i80(i1: i80, i2: i80) returns (i1) { (if $eq.i80.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i88.bool(i1: i88, i2: i88) returns (bool) { (i1 == i2) }
function {:define} $eq.i88(i1: i88, i2: i88) returns (i1) { (if $eq.i88.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i96.bool(i1: i96, i2: i96) returns (bool) { (i1 == i2) }
function {:define} $eq.i96(i1: i96, i2: i96) returns (i1) { (if $eq.i96.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i128.bool(i1: i128, i2: i128) returns (bool) { (i1 == i2) }
function {:define} $eq.i128(i1: i128, i2: i128) returns (i1) { (if $eq.i128.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i160.bool(i1: i160, i2: i160) returns (bool) { (i1 == i2) }
function {:define} $eq.i160(i1: i160, i2: i160) returns (i1) { (if $eq.i160.bool(i1, i2) then 1 else 0) }
function {:define} $eq.i256.bool(i1: i256, i2: i256) returns (bool) { (i1 == i2) }
function {:define} $eq.i256(i1: i256, i2: i256) returns (i1) { (if $eq.i256.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i1.bool(i1: i1, i2: i1) returns (bool) { (i1 != i2) }
function {:define} $ne.i1(i1: i1, i2: i1) returns (i1) { (if $ne.i1.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i5.bool(i1: i5, i2: i5) returns (bool) { (i1 != i2) }
function {:define} $ne.i5(i1: i5, i2: i5) returns (i1) { (if $ne.i5.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i6.bool(i1: i6, i2: i6) returns (bool) { (i1 != i2) }
function {:define} $ne.i6(i1: i6, i2: i6) returns (i1) { (if $ne.i6.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i8.bool(i1: i8, i2: i8) returns (bool) { (i1 != i2) }
function {:define} $ne.i8(i1: i8, i2: i8) returns (i1) { (if $ne.i8.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i16.bool(i1: i16, i2: i16) returns (bool) { (i1 != i2) }
function {:define} $ne.i16(i1: i16, i2: i16) returns (i1) { (if $ne.i16.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i24.bool(i1: i24, i2: i24) returns (bool) { (i1 != i2) }
function {:define} $ne.i24(i1: i24, i2: i24) returns (i1) { (if $ne.i24.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i32.bool(i1: i32, i2: i32) returns (bool) { (i1 != i2) }
function {:define} $ne.i32(i1: i32, i2: i32) returns (i1) { (if $ne.i32.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i40.bool(i1: i40, i2: i40) returns (bool) { (i1 != i2) }
function {:define} $ne.i40(i1: i40, i2: i40) returns (i1) { (if $ne.i40.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i48.bool(i1: i48, i2: i48) returns (bool) { (i1 != i2) }
function {:define} $ne.i48(i1: i48, i2: i48) returns (i1) { (if $ne.i48.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i56.bool(i1: i56, i2: i56) returns (bool) { (i1 != i2) }
function {:define} $ne.i56(i1: i56, i2: i56) returns (i1) { (if $ne.i56.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i64.bool(i1: i64, i2: i64) returns (bool) { (i1 != i2) }
function {:define} $ne.i64(i1: i64, i2: i64) returns (i1) { (if $ne.i64.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i80.bool(i1: i80, i2: i80) returns (bool) { (i1 != i2) }
function {:define} $ne.i80(i1: i80, i2: i80) returns (i1) { (if $ne.i80.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i88.bool(i1: i88, i2: i88) returns (bool) { (i1 != i2) }
function {:define} $ne.i88(i1: i88, i2: i88) returns (i1) { (if $ne.i88.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i96.bool(i1: i96, i2: i96) returns (bool) { (i1 != i2) }
function {:define} $ne.i96(i1: i96, i2: i96) returns (i1) { (if $ne.i96.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i128.bool(i1: i128, i2: i128) returns (bool) { (i1 != i2) }
function {:define} $ne.i128(i1: i128, i2: i128) returns (i1) { (if $ne.i128.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i160.bool(i1: i160, i2: i160) returns (bool) { (i1 != i2) }
function {:define} $ne.i160(i1: i160, i2: i160) returns (i1) { (if $ne.i160.bool(i1, i2) then 1 else 0) }
function {:define} $ne.i256.bool(i1: i256, i2: i256) returns (bool) { (i1 != i2) }
function {:define} $ne.i256(i1: i256, i2: i256) returns (i1) { (if $ne.i256.bool(i1, i2) then 1 else 0) }
// Integer load/store operations
function {:define} $load.i1(M: [ref] i1, p: ref) returns (i1) { M[p] }
function {:define} $store.i1(M: [ref] i1, p: ref, i: i1) returns ([ref] i1) { M[p := i] }
function {:define} $load.i5(M: [ref] i5, p: ref) returns (i5) { M[p] }
function {:define} $store.i5(M: [ref] i5, p: ref, i: i5) returns ([ref] i5) { M[p := i] }
function {:define} $load.i6(M: [ref] i6, p: ref) returns (i6) { M[p] }
function {:define} $store.i6(M: [ref] i6, p: ref, i: i6) returns ([ref] i6) { M[p := i] }
function {:define} $load.i8(M: [ref] i8, p: ref) returns (i8) { M[p] }
function {:define} $store.i8(M: [ref] i8, p: ref, i: i8) returns ([ref] i8) { M[p := i] }
function {:define} $load.i16(M: [ref] i16, p: ref) returns (i16) { M[p] }
function {:define} $store.i16(M: [ref] i16, p: ref, i: i16) returns ([ref] i16) { M[p := i] }
function {:define} $load.i24(M: [ref] i24, p: ref) returns (i24) { M[p] }
function {:define} $store.i24(M: [ref] i24, p: ref, i: i24) returns ([ref] i24) { M[p := i] }
function {:define} $load.i32(M: [ref] i32, p: ref) returns (i32) { M[p] }
function {:define} $store.i32(M: [ref] i32, p: ref, i: i32) returns ([ref] i32) { M[p := i] }
function {:define} $load.i40(M: [ref] i40, p: ref) returns (i40) { M[p] }
function {:define} $store.i40(M: [ref] i40, p: ref, i: i40) returns ([ref] i40) { M[p := i] }
function {:define} $load.i48(M: [ref] i48, p: ref) returns (i48) { M[p] }
function {:define} $store.i48(M: [ref] i48, p: ref, i: i48) returns ([ref] i48) { M[p := i] }
function {:define} $load.i56(M: [ref] i56, p: ref) returns (i56) { M[p] }
function {:define} $store.i56(M: [ref] i56, p: ref, i: i56) returns ([ref] i56) { M[p := i] }
function {:define} $load.i64(M: [ref] i64, p: ref) returns (i64) { M[p] }
function {:define} $store.i64(M: [ref] i64, p: ref, i: i64) returns ([ref] i64) { M[p := i] }
function {:define} $load.i80(M: [ref] i80, p: ref) returns (i80) { M[p] }
function {:define} $store.i80(M: [ref] i80, p: ref, i: i80) returns ([ref] i80) { M[p := i] }
function {:define} $load.i88(M: [ref] i88, p: ref) returns (i88) { M[p] }
function {:define} $store.i88(M: [ref] i88, p: ref, i: i88) returns ([ref] i88) { M[p := i] }
function {:define} $load.i96(M: [ref] i96, p: ref) returns (i96) { M[p] }
function {:define} $store.i96(M: [ref] i96, p: ref, i: i96) returns ([ref] i96) { M[p := i] }
function {:define} $load.i128(M: [ref] i128, p: ref) returns (i128) { M[p] }
function {:define} $store.i128(M: [ref] i128, p: ref, i: i128) returns ([ref] i128) { M[p := i] }
function {:define} $load.i160(M: [ref] i160, p: ref) returns (i160) { M[p] }
function {:define} $store.i160(M: [ref] i160, p: ref, i: i160) returns ([ref] i160) { M[p := i] }
function {:define} $load.i256(M: [ref] i256, p: ref) returns (i256) { M[p] }
function {:define} $store.i256(M: [ref] i256, p: ref, i: i256) returns ([ref] i256) { M[p := i] }
// Conversion between integer types
function {:define} $trunc.i5.i1(i: i5) returns (i1) { i }
function {:define} $trunc.i6.i1(i: i6) returns (i1) { i }
function {:define} $trunc.i8.i1(i: i8) returns (i1) { i }
function {:define} $trunc.i16.i1(i: i16) returns (i1) { i }
function {:define} $trunc.i24.i1(i: i24) returns (i1) { i }
function {:define} $trunc.i32.i1(i: i32) returns (i1) { i }
function {:define} $trunc.i40.i1(i: i40) returns (i1) { i }
function {:define} $trunc.i48.i1(i: i48) returns (i1) { i }
function {:define} $trunc.i56.i1(i: i56) returns (i1) { i }
function {:define} $trunc.i64.i1(i: i64) returns (i1) { i }
function {:define} $trunc.i80.i1(i: i80) returns (i1) { i }
function {:define} $trunc.i88.i1(i: i88) returns (i1) { i }
function {:define} $trunc.i96.i1(i: i96) returns (i1) { i }
function {:define} $trunc.i128.i1(i: i128) returns (i1) { i }
function {:define} $trunc.i160.i1(i: i160) returns (i1) { i }
function {:define} $trunc.i256.i1(i: i256) returns (i1) { i }
function {:define} $trunc.i6.i5(i: i6) returns (i5) { i }
function {:define} $trunc.i8.i5(i: i8) returns (i5) { i }
function {:define} $trunc.i16.i5(i: i16) returns (i5) { i }
function {:define} $trunc.i24.i5(i: i24) returns (i5) { i }
function {:define} $trunc.i32.i5(i: i32) returns (i5) { i }
function {:define} $trunc.i40.i5(i: i40) returns (i5) { i }
function {:define} $trunc.i48.i5(i: i48) returns (i5) { i }
function {:define} $trunc.i56.i5(i: i56) returns (i5) { i }
function {:define} $trunc.i64.i5(i: i64) returns (i5) { i }
function {:define} $trunc.i80.i5(i: i80) returns (i5) { i }
function {:define} $trunc.i88.i5(i: i88) returns (i5) { i }
function {:define} $trunc.i96.i5(i: i96) returns (i5) { i }
function {:define} $trunc.i128.i5(i: i128) returns (i5) { i }
function {:define} $trunc.i160.i5(i: i160) returns (i5) { i }
function {:define} $trunc.i256.i5(i: i256) returns (i5) { i }
function {:define} $trunc.i8.i6(i: i8) returns (i6) { i }
function {:define} $trunc.i16.i6(i: i16) returns (i6) { i }
function {:define} $trunc.i24.i6(i: i24) returns (i6) { i }
function {:define} $trunc.i32.i6(i: i32) returns (i6) { i }
function {:define} $trunc.i40.i6(i: i40) returns (i6) { i }
function {:define} $trunc.i48.i6(i: i48) returns (i6) { i }
function {:define} $trunc.i56.i6(i: i56) returns (i6) { i }
function {:define} $trunc.i64.i6(i: i64) returns (i6) { i }
function {:define} $trunc.i80.i6(i: i80) returns (i6) { i }
function {:define} $trunc.i88.i6(i: i88) returns (i6) { i }
function {:define} $trunc.i96.i6(i: i96) returns (i6) { i }
function {:define} $trunc.i128.i6(i: i128) returns (i6) { i }
function {:define} $trunc.i160.i6(i: i160) returns (i6) { i }
function {:define} $trunc.i256.i6(i: i256) returns (i6) { i }
function {:define} $trunc.i16.i8(i: i16) returns (i8) { i }
function {:define} $trunc.i24.i8(i: i24) returns (i8) { i }
function {:define} $trunc.i32.i8(i: i32) returns (i8) { i }
function {:define} $trunc.i40.i8(i: i40) returns (i8) { i }
function {:define} $trunc.i48.i8(i: i48) returns (i8) { i }
function {:define} $trunc.i56.i8(i: i56) returns (i8) { i }
function {:define} $trunc.i64.i8(i: i64) returns (i8) { i }
function {:define} $trunc.i80.i8(i: i80) returns (i8) { i }
function {:define} $trunc.i88.i8(i: i88) returns (i8) { i }
function {:define} $trunc.i96.i8(i: i96) returns (i8) { i }
function {:define} $trunc.i128.i8(i: i128) returns (i8) { i }
function {:define} $trunc.i160.i8(i: i160) returns (i8) { i }
function {:define} $trunc.i256.i8(i: i256) returns (i8) { i }
function {:define} $trunc.i24.i16(i: i24) returns (i16) { i }
function {:define} $trunc.i32.i16(i: i32) returns (i16) { i }
function {:define} $trunc.i40.i16(i: i40) returns (i16) { i }
function {:define} $trunc.i48.i16(i: i48) returns (i16) { i }
function {:define} $trunc.i56.i16(i: i56) returns (i16) { i }
function {:define} $trunc.i64.i16(i: i64) returns (i16) { i }
function {:define} $trunc.i80.i16(i: i80) returns (i16) { i }
function {:define} $trunc.i88.i16(i: i88) returns (i16) { i }
function {:define} $trunc.i96.i16(i: i96) returns (i16) { i }
function {:define} $trunc.i128.i16(i: i128) returns (i16) { i }
function {:define} $trunc.i160.i16(i: i160) returns (i16) { i }
function {:define} $trunc.i256.i16(i: i256) returns (i16) { i }
function {:define} $trunc.i32.i24(i: i32) returns (i24) { i }
function {:define} $trunc.i40.i24(i: i40) returns (i24) { i }
function {:define} $trunc.i48.i24(i: i48) returns (i24) { i }
function {:define} $trunc.i56.i24(i: i56) returns (i24) { i }
function {:define} $trunc.i64.i24(i: i64) returns (i24) { i }
function {:define} $trunc.i80.i24(i: i80) returns (i24) { i }
function {:define} $trunc.i88.i24(i: i88) returns (i24) { i }
function {:define} $trunc.i96.i24(i: i96) returns (i24) { i }
function {:define} $trunc.i128.i24(i: i128) returns (i24) { i }
function {:define} $trunc.i160.i24(i: i160) returns (i24) { i }
function {:define} $trunc.i256.i24(i: i256) returns (i24) { i }
function {:define} $trunc.i40.i32(i: i40) returns (i32) { i }
function {:define} $trunc.i48.i32(i: i48) returns (i32) { i }
function {:define} $trunc.i56.i32(i: i56) returns (i32) { i }
function {:define} $trunc.i64.i32(i: i64) returns (i32) { i }
function {:define} $trunc.i80.i32(i: i80) returns (i32) { i }
function {:define} $trunc.i88.i32(i: i88) returns (i32) { i }
function {:define} $trunc.i96.i32(i: i96) returns (i32) { i }
function {:define} $trunc.i128.i32(i: i128) returns (i32) { i }
function {:define} $trunc.i160.i32(i: i160) returns (i32) { i }
function {:define} $trunc.i256.i32(i: i256) returns (i32) { i }
function {:define} $trunc.i48.i40(i: i48) returns (i40) { i }
function {:define} $trunc.i56.i40(i: i56) returns (i40) { i }
function {:define} $trunc.i64.i40(i: i64) returns (i40) { i }
function {:define} $trunc.i80.i40(i: i80) returns (i40) { i }
function {:define} $trunc.i88.i40(i: i88) returns (i40) { i }
function {:define} $trunc.i96.i40(i: i96) returns (i40) { i }
function {:define} $trunc.i128.i40(i: i128) returns (i40) { i }
function {:define} $trunc.i160.i40(i: i160) returns (i40) { i }
function {:define} $trunc.i256.i40(i: i256) returns (i40) { i }
function {:define} $trunc.i56.i48(i: i56) returns (i48) { i }
function {:define} $trunc.i64.i48(i: i64) returns (i48) { i }
function {:define} $trunc.i80.i48(i: i80) returns (i48) { i }
function {:define} $trunc.i88.i48(i: i88) returns (i48) { i }
function {:define} $trunc.i96.i48(i: i96) returns (i48) { i }
function {:define} $trunc.i128.i48(i: i128) returns (i48) { i }
function {:define} $trunc.i160.i48(i: i160) returns (i48) { i }
function {:define} $trunc.i256.i48(i: i256) returns (i48) { i }
function {:define} $trunc.i64.i56(i: i64) returns (i56) { i }
function {:define} $trunc.i80.i56(i: i80) returns (i56) { i }
function {:define} $trunc.i88.i56(i: i88) returns (i56) { i }
function {:define} $trunc.i96.i56(i: i96) returns (i56) { i }
function {:define} $trunc.i128.i56(i: i128) returns (i56) { i }
function {:define} $trunc.i160.i56(i: i160) returns (i56) { i }
function {:define} $trunc.i256.i56(i: i256) returns (i56) { i }
function {:define} $trunc.i80.i64(i: i80) returns (i64) { i }
function {:define} $trunc.i88.i64(i: i88) returns (i64) { i }
function {:define} $trunc.i96.i64(i: i96) returns (i64) { i }
function {:define} $trunc.i128.i64(i: i128) returns (i64) { i }
function {:define} $trunc.i160.i64(i: i160) returns (i64) { i }
function {:define} $trunc.i256.i64(i: i256) returns (i64) { i }
function {:define} $trunc.i88.i80(i: i88) returns (i80) { i }
function {:define} $trunc.i96.i80(i: i96) returns (i80) { i }
function {:define} $trunc.i128.i80(i: i128) returns (i80) { i }
function {:define} $trunc.i160.i80(i: i160) returns (i80) { i }
function {:define} $trunc.i256.i80(i: i256) returns (i80) { i }
function {:define} $trunc.i96.i88(i: i96) returns (i88) { i }
function {:define} $trunc.i128.i88(i: i128) returns (i88) { i }
function {:define} $trunc.i160.i88(i: i160) returns (i88) { i }
function {:define} $trunc.i256.i88(i: i256) returns (i88) { i }
function {:define} $trunc.i128.i96(i: i128) returns (i96) { i }
function {:define} $trunc.i160.i96(i: i160) returns (i96) { i }
function {:define} $trunc.i256.i96(i: i256) returns (i96) { i }
function {:define} $trunc.i160.i128(i: i160) returns (i128) { i }
function {:define} $trunc.i256.i128(i: i256) returns (i128) { i }
function {:define} $trunc.i256.i160(i: i256) returns (i160) { i }
function {:define} $sext.i1.i5(i: i1) returns (i5) { i }
function {:define} $sext.i1.i6(i: i1) returns (i6) { i }
function {:define} $sext.i1.i8(i: i1) returns (i8) { i }
function {:define} $sext.i1.i16(i: i1) returns (i16) { i }
function {:define} $sext.i1.i24(i: i1) returns (i24) { i }
function {:define} $sext.i1.i32(i: i1) returns (i32) { i }
function {:define} $sext.i1.i40(i: i1) returns (i40) { i }
function {:define} $sext.i1.i48(i: i1) returns (i48) { i }
function {:define} $sext.i1.i56(i: i1) returns (i56) { i }
function {:define} $sext.i1.i64(i: i1) returns (i64) { i }
function {:define} $sext.i1.i80(i: i1) returns (i80) { i }
function {:define} $sext.i1.i88(i: i1) returns (i88) { i }
function {:define} $sext.i1.i96(i: i1) returns (i96) { i }
function {:define} $sext.i1.i128(i: i1) returns (i128) { i }
function {:define} $sext.i1.i160(i: i1) returns (i160) { i }
function {:define} $sext.i1.i256(i: i1) returns (i256) { i }
function {:define} $sext.i5.i6(i: i5) returns (i6) { i }
function {:define} $sext.i5.i8(i: i5) returns (i8) { i }
function {:define} $sext.i5.i16(i: i5) returns (i16) { i }
function {:define} $sext.i5.i24(i: i5) returns (i24) { i }
function {:define} $sext.i5.i32(i: i5) returns (i32) { i }
function {:define} $sext.i5.i40(i: i5) returns (i40) { i }
function {:define} $sext.i5.i48(i: i5) returns (i48) { i }
function {:define} $sext.i5.i56(i: i5) returns (i56) { i }
function {:define} $sext.i5.i64(i: i5) returns (i64) { i }
function {:define} $sext.i5.i80(i: i5) returns (i80) { i }
function {:define} $sext.i5.i88(i: i5) returns (i88) { i }
function {:define} $sext.i5.i96(i: i5) returns (i96) { i }
function {:define} $sext.i5.i128(i: i5) returns (i128) { i }
function {:define} $sext.i5.i160(i: i5) returns (i160) { i }
function {:define} $sext.i5.i256(i: i5) returns (i256) { i }
function {:define} $sext.i6.i8(i: i6) returns (i8) { i }
function {:define} $sext.i6.i16(i: i6) returns (i16) { i }
function {:define} $sext.i6.i24(i: i6) returns (i24) { i }
function {:define} $sext.i6.i32(i: i6) returns (i32) { i }
function {:define} $sext.i6.i40(i: i6) returns (i40) { i }
function {:define} $sext.i6.i48(i: i6) returns (i48) { i }
function {:define} $sext.i6.i56(i: i6) returns (i56) { i }
function {:define} $sext.i6.i64(i: i6) returns (i64) { i }
function {:define} $sext.i6.i80(i: i6) returns (i80) { i }
function {:define} $sext.i6.i88(i: i6) returns (i88) { i }
function {:define} $sext.i6.i96(i: i6) returns (i96) { i }
function {:define} $sext.i6.i128(i: i6) returns (i128) { i }
function {:define} $sext.i6.i160(i: i6) returns (i160) { i }
function {:define} $sext.i6.i256(i: i6) returns (i256) { i }
function {:define} $sext.i8.i16(i: i8) returns (i16) { i }
function {:define} $sext.i8.i24(i: i8) returns (i24) { i }
function {:define} $sext.i8.i32(i: i8) returns (i32) { i }
function {:define} $sext.i8.i40(i: i8) returns (i40) { i }
function {:define} $sext.i8.i48(i: i8) returns (i48) { i }
function {:define} $sext.i8.i56(i: i8) returns (i56) { i }
function {:define} $sext.i8.i64(i: i8) returns (i64) { i }
function {:define} $sext.i8.i80(i: i8) returns (i80) { i }
function {:define} $sext.i8.i88(i: i8) returns (i88) { i }
function {:define} $sext.i8.i96(i: i8) returns (i96) { i }
function {:define} $sext.i8.i128(i: i8) returns (i128) { i }
function {:define} $sext.i8.i160(i: i8) returns (i160) { i }
function {:define} $sext.i8.i256(i: i8) returns (i256) { i }
function {:define} $sext.i16.i24(i: i16) returns (i24) { i }
function {:define} $sext.i16.i32(i: i16) returns (i32) { i }
function {:define} $sext.i16.i40(i: i16) returns (i40) { i }
function {:define} $sext.i16.i48(i: i16) returns (i48) { i }
function {:define} $sext.i16.i56(i: i16) returns (i56) { i }
function {:define} $sext.i16.i64(i: i16) returns (i64) { i }
function {:define} $sext.i16.i80(i: i16) returns (i80) { i }
function {:define} $sext.i16.i88(i: i16) returns (i88) { i }
function {:define} $sext.i16.i96(i: i16) returns (i96) { i }
function {:define} $sext.i16.i128(i: i16) returns (i128) { i }
function {:define} $sext.i16.i160(i: i16) returns (i160) { i }
function {:define} $sext.i16.i256(i: i16) returns (i256) { i }
function {:define} $sext.i24.i32(i: i24) returns (i32) { i }
function {:define} $sext.i24.i40(i: i24) returns (i40) { i }
function {:define} $sext.i24.i48(i: i24) returns (i48) { i }
function {:define} $sext.i24.i56(i: i24) returns (i56) { i }
function {:define} $sext.i24.i64(i: i24) returns (i64) { i }
function {:define} $sext.i24.i80(i: i24) returns (i80) { i }
function {:define} $sext.i24.i88(i: i24) returns (i88) { i }
function {:define} $sext.i24.i96(i: i24) returns (i96) { i }
function {:define} $sext.i24.i128(i: i24) returns (i128) { i }
function {:define} $sext.i24.i160(i: i24) returns (i160) { i }
function {:define} $sext.i24.i256(i: i24) returns (i256) { i }
function {:define} $sext.i32.i40(i: i32) returns (i40) { i }
function {:define} $sext.i32.i48(i: i32) returns (i48) { i }
function {:define} $sext.i32.i56(i: i32) returns (i56) { i }
function {:define} $sext.i32.i64(i: i32) returns (i64) { i }
function {:define} $sext.i32.i80(i: i32) returns (i80) { i }
function {:define} $sext.i32.i88(i: i32) returns (i88) { i }
function {:define} $sext.i32.i96(i: i32) returns (i96) { i }
function {:define} $sext.i32.i128(i: i32) returns (i128) { i }
function {:define} $sext.i32.i160(i: i32) returns (i160) { i }
function {:define} $sext.i32.i256(i: i32) returns (i256) { i }
function {:define} $sext.i40.i48(i: i40) returns (i48) { i }
function {:define} $sext.i40.i56(i: i40) returns (i56) { i }
function {:define} $sext.i40.i64(i: i40) returns (i64) { i }
function {:define} $sext.i40.i80(i: i40) returns (i80) { i }
function {:define} $sext.i40.i88(i: i40) returns (i88) { i }
function {:define} $sext.i40.i96(i: i40) returns (i96) { i }
function {:define} $sext.i40.i128(i: i40) returns (i128) { i }
function {:define} $sext.i40.i160(i: i40) returns (i160) { i }
function {:define} $sext.i40.i256(i: i40) returns (i256) { i }
function {:define} $sext.i48.i56(i: i48) returns (i56) { i }
function {:define} $sext.i48.i64(i: i48) returns (i64) { i }
function {:define} $sext.i48.i80(i: i48) returns (i80) { i }
function {:define} $sext.i48.i88(i: i48) returns (i88) { i }
function {:define} $sext.i48.i96(i: i48) returns (i96) { i }
function {:define} $sext.i48.i128(i: i48) returns (i128) { i }
function {:define} $sext.i48.i160(i: i48) returns (i160) { i }
function {:define} $sext.i48.i256(i: i48) returns (i256) { i }
function {:define} $sext.i56.i64(i: i56) returns (i64) { i }
function {:define} $sext.i56.i80(i: i56) returns (i80) { i }
function {:define} $sext.i56.i88(i: i56) returns (i88) { i }
function {:define} $sext.i56.i96(i: i56) returns (i96) { i }
function {:define} $sext.i56.i128(i: i56) returns (i128) { i }
function {:define} $sext.i56.i160(i: i56) returns (i160) { i }
function {:define} $sext.i56.i256(i: i56) returns (i256) { i }
function {:define} $sext.i64.i80(i: i64) returns (i80) { i }
function {:define} $sext.i64.i88(i: i64) returns (i88) { i }
function {:define} $sext.i64.i96(i: i64) returns (i96) { i }
function {:define} $sext.i64.i128(i: i64) returns (i128) { i }
function {:define} $sext.i64.i160(i: i64) returns (i160) { i }
function {:define} $sext.i64.i256(i: i64) returns (i256) { i }
function {:define} $sext.i80.i88(i: i80) returns (i88) { i }
function {:define} $sext.i80.i96(i: i80) returns (i96) { i }
function {:define} $sext.i80.i128(i: i80) returns (i128) { i }
function {:define} $sext.i80.i160(i: i80) returns (i160) { i }
function {:define} $sext.i80.i256(i: i80) returns (i256) { i }
function {:define} $sext.i88.i96(i: i88) returns (i96) { i }
function {:define} $sext.i88.i128(i: i88) returns (i128) { i }
function {:define} $sext.i88.i160(i: i88) returns (i160) { i }
function {:define} $sext.i88.i256(i: i88) returns (i256) { i }
function {:define} $sext.i96.i128(i: i96) returns (i128) { i }
function {:define} $sext.i96.i160(i: i96) returns (i160) { i }
function {:define} $sext.i96.i256(i: i96) returns (i256) { i }
function {:define} $sext.i128.i160(i: i128) returns (i160) { i }
function {:define} $sext.i128.i256(i: i128) returns (i256) { i }
function {:define} $sext.i160.i256(i: i160) returns (i256) { i }
function {:define} $zext.i1.i5(i: i1) returns (i5) { i }
function {:define} $zext.i1.i6(i: i1) returns (i6) { i }
function {:define} $zext.i1.i8(i: i1) returns (i8) { i }
function {:define} $zext.i1.i16(i: i1) returns (i16) { i }
function {:define} $zext.i1.i24(i: i1) returns (i24) { i }
function {:define} $zext.i1.i32(i: i1) returns (i32) { i }
function {:define} $zext.i1.i40(i: i1) returns (i40) { i }
function {:define} $zext.i1.i48(i: i1) returns (i48) { i }
function {:define} $zext.i1.i56(i: i1) returns (i56) { i }
function {:define} $zext.i1.i64(i: i1) returns (i64) { i }
function {:define} $zext.i1.i80(i: i1) returns (i80) { i }
function {:define} $zext.i1.i88(i: i1) returns (i88) { i }
function {:define} $zext.i1.i96(i: i1) returns (i96) { i }
function {:define} $zext.i1.i128(i: i1) returns (i128) { i }
function {:define} $zext.i1.i160(i: i1) returns (i160) { i }
function {:define} $zext.i1.i256(i: i1) returns (i256) { i }
function {:define} $zext.i5.i6(i: i5) returns (i6) { i }
function {:define} $zext.i5.i8(i: i5) returns (i8) { i }
function {:define} $zext.i5.i16(i: i5) returns (i16) { i }
function {:define} $zext.i5.i24(i: i5) returns (i24) { i }
function {:define} $zext.i5.i32(i: i5) returns (i32) { i }
function {:define} $zext.i5.i40(i: i5) returns (i40) { i }
function {:define} $zext.i5.i48(i: i5) returns (i48) { i }
function {:define} $zext.i5.i56(i: i5) returns (i56) { i }
function {:define} $zext.i5.i64(i: i5) returns (i64) { i }
function {:define} $zext.i5.i80(i: i5) returns (i80) { i }
function {:define} $zext.i5.i88(i: i5) returns (i88) { i }
function {:define} $zext.i5.i96(i: i5) returns (i96) { i }
function {:define} $zext.i5.i128(i: i5) returns (i128) { i }
function {:define} $zext.i5.i160(i: i5) returns (i160) { i }
function {:define} $zext.i5.i256(i: i5) returns (i256) { i }
function {:define} $zext.i6.i8(i: i6) returns (i8) { i }
function {:define} $zext.i6.i16(i: i6) returns (i16) { i }
function {:define} $zext.i6.i24(i: i6) returns (i24) { i }
function {:define} $zext.i6.i32(i: i6) returns (i32) { i }
function {:define} $zext.i6.i40(i: i6) returns (i40) { i }
function {:define} $zext.i6.i48(i: i6) returns (i48) { i }
function {:define} $zext.i6.i56(i: i6) returns (i56) { i }
function {:define} $zext.i6.i64(i: i6) returns (i64) { i }
function {:define} $zext.i6.i80(i: i6) returns (i80) { i }
function {:define} $zext.i6.i88(i: i6) returns (i88) { i }
function {:define} $zext.i6.i96(i: i6) returns (i96) { i }
function {:define} $zext.i6.i128(i: i6) returns (i128) { i }
function {:define} $zext.i6.i160(i: i6) returns (i160) { i }
function {:define} $zext.i6.i256(i: i6) returns (i256) { i }
function {:define} $zext.i8.i16(i: i8) returns (i16) { i }
function {:define} $zext.i8.i24(i: i8) returns (i24) { i }
function {:define} $zext.i8.i32(i: i8) returns (i32) { i }
function {:define} $zext.i8.i40(i: i8) returns (i40) { i }
function {:define} $zext.i8.i48(i: i8) returns (i48) { i }
function {:define} $zext.i8.i56(i: i8) returns (i56) { i }
function {:define} $zext.i8.i64(i: i8) returns (i64) { i }
function {:define} $zext.i8.i80(i: i8) returns (i80) { i }
function {:define} $zext.i8.i88(i: i8) returns (i88) { i }
function {:define} $zext.i8.i96(i: i8) returns (i96) { i }
function {:define} $zext.i8.i128(i: i8) returns (i128) { i }
function {:define} $zext.i8.i160(i: i8) returns (i160) { i }
function {:define} $zext.i8.i256(i: i8) returns (i256) { i }
function {:define} $zext.i16.i24(i: i16) returns (i24) { i }
function {:define} $zext.i16.i32(i: i16) returns (i32) { i }
function {:define} $zext.i16.i40(i: i16) returns (i40) { i }
function {:define} $zext.i16.i48(i: i16) returns (i48) { i }
function {:define} $zext.i16.i56(i: i16) returns (i56) { i }
function {:define} $zext.i16.i64(i: i16) returns (i64) { i }
function {:define} $zext.i16.i80(i: i16) returns (i80) { i }
function {:define} $zext.i16.i88(i: i16) returns (i88) { i }
function {:define} $zext.i16.i96(i: i16) returns (i96) { i }
function {:define} $zext.i16.i128(i: i16) returns (i128) { i }
function {:define} $zext.i16.i160(i: i16) returns (i160) { i }
function {:define} $zext.i16.i256(i: i16) returns (i256) { i }
function {:define} $zext.i24.i32(i: i24) returns (i32) { i }
function {:define} $zext.i24.i40(i: i24) returns (i40) { i }
function {:define} $zext.i24.i48(i: i24) returns (i48) { i }
function {:define} $zext.i24.i56(i: i24) returns (i56) { i }
function {:define} $zext.i24.i64(i: i24) returns (i64) { i }
function {:define} $zext.i24.i80(i: i24) returns (i80) { i }
function {:define} $zext.i24.i88(i: i24) returns (i88) { i }
function {:define} $zext.i24.i96(i: i24) returns (i96) { i }
function {:define} $zext.i24.i128(i: i24) returns (i128) { i }
function {:define} $zext.i24.i160(i: i24) returns (i160) { i }
function {:define} $zext.i24.i256(i: i24) returns (i256) { i }
function {:define} $zext.i32.i40(i: i32) returns (i40) { i }
function {:define} $zext.i32.i48(i: i32) returns (i48) { i }
function {:define} $zext.i32.i56(i: i32) returns (i56) { i }
function {:define} $zext.i32.i64(i: i32) returns (i64) { i }
function {:define} $zext.i32.i80(i: i32) returns (i80) { i }
function {:define} $zext.i32.i88(i: i32) returns (i88) { i }
function {:define} $zext.i32.i96(i: i32) returns (i96) { i }
function {:define} $zext.i32.i128(i: i32) returns (i128) { i }
function {:define} $zext.i32.i160(i: i32) returns (i160) { i }
function {:define} $zext.i32.i256(i: i32) returns (i256) { i }
function {:define} $zext.i40.i48(i: i40) returns (i48) { i }
function {:define} $zext.i40.i56(i: i40) returns (i56) { i }
function {:define} $zext.i40.i64(i: i40) returns (i64) { i }
function {:define} $zext.i40.i80(i: i40) returns (i80) { i }
function {:define} $zext.i40.i88(i: i40) returns (i88) { i }
function {:define} $zext.i40.i96(i: i40) returns (i96) { i }
function {:define} $zext.i40.i128(i: i40) returns (i128) { i }
function {:define} $zext.i40.i160(i: i40) returns (i160) { i }
function {:define} $zext.i40.i256(i: i40) returns (i256) { i }
function {:define} $zext.i48.i56(i: i48) returns (i56) { i }
function {:define} $zext.i48.i64(i: i48) returns (i64) { i }
function {:define} $zext.i48.i80(i: i48) returns (i80) { i }
function {:define} $zext.i48.i88(i: i48) returns (i88) { i }
function {:define} $zext.i48.i96(i: i48) returns (i96) { i }
function {:define} $zext.i48.i128(i: i48) returns (i128) { i }
function {:define} $zext.i48.i160(i: i48) returns (i160) { i }
function {:define} $zext.i48.i256(i: i48) returns (i256) { i }
function {:define} $zext.i56.i64(i: i56) returns (i64) { i }
function {:define} $zext.i56.i80(i: i56) returns (i80) { i }
function {:define} $zext.i56.i88(i: i56) returns (i88) { i }
function {:define} $zext.i56.i96(i: i56) returns (i96) { i }
function {:define} $zext.i56.i128(i: i56) returns (i128) { i }
function {:define} $zext.i56.i160(i: i56) returns (i160) { i }
function {:define} $zext.i56.i256(i: i56) returns (i256) { i }
function {:define} $zext.i64.i80(i: i64) returns (i80) { i }
function {:define} $zext.i64.i88(i: i64) returns (i88) { i }
function {:define} $zext.i64.i96(i: i64) returns (i96) { i }
function {:define} $zext.i64.i128(i: i64) returns (i128) { i }
function {:define} $zext.i64.i160(i: i64) returns (i160) { i }
function {:define} $zext.i64.i256(i: i64) returns (i256) { i }
function {:define} $zext.i80.i88(i: i80) returns (i88) { i }
function {:define} $zext.i80.i96(i: i80) returns (i96) { i }
function {:define} $zext.i80.i128(i: i80) returns (i128) { i }
function {:define} $zext.i80.i160(i: i80) returns (i160) { i }
function {:define} $zext.i80.i256(i: i80) returns (i256) { i }
function {:define} $zext.i88.i96(i: i88) returns (i96) { i }
function {:define} $zext.i88.i128(i: i88) returns (i128) { i }
function {:define} $zext.i88.i160(i: i88) returns (i160) { i }
function {:define} $zext.i88.i256(i: i88) returns (i256) { i }
function {:define} $zext.i96.i128(i: i96) returns (i128) { i }
function {:define} $zext.i96.i160(i: i96) returns (i160) { i }
function {:define} $zext.i96.i256(i: i96) returns (i256) { i }
function {:define} $zext.i128.i160(i: i128) returns (i160) { i }
function {:define} $zext.i128.i256(i: i128) returns (i256) { i }
function {:define} $zext.i160.i256(i: i160) returns (i256) { i }
function $extractvalue.i1(p: ref, i: int) returns (i1);
function $extractvalue.i5(p: ref, i: int) returns (i5);
function $extractvalue.i6(p: ref, i: int) returns (i6);
function $extractvalue.i8(p: ref, i: int) returns (i8);
function $extractvalue.i16(p: ref, i: int) returns (i16);
function $extractvalue.i24(p: ref, i: int) returns (i24);
function $extractvalue.i32(p: ref, i: int) returns (i32);
function $extractvalue.i40(p: ref, i: int) returns (i40);
function $extractvalue.i48(p: ref, i: int) returns (i48);
function $extractvalue.i56(p: ref, i: int) returns (i56);
function $extractvalue.i64(p: ref, i: int) returns (i64);
function $extractvalue.i80(p: ref, i: int) returns (i80);
function $extractvalue.i88(p: ref, i: int) returns (i88);
function $extractvalue.i96(p: ref, i: int) returns (i96);
function $extractvalue.i128(p: ref, i: int) returns (i128);
function $extractvalue.i160(p: ref, i: int) returns (i160);
function $extractvalue.i256(p: ref, i: int) returns (i256);
// Pointer arithmetic operations
function {:define} $add.ref(p1: ref, p2: ref) returns (ref) { $add.i64(p1, p2) }
function {:define} $sub.ref(p1: ref, p2: ref) returns (ref) { $sub.i64(p1, p2) }
function {:define} $mul.ref(p1: ref, p2: ref) returns (ref) { $mul.i64(p1, p2) }

// Pointer predicates
function {:define} $eq.ref(p1: ref, p2: ref) returns (i1) { (if $eq.i64.bool(p1, p2) then 1 else 0) }
function {:define} $eq.ref.bool(p1: ref, p2: ref) returns (bool) { $eq.i64.bool(p1, p2) }
function {:define} $ne.ref(p1: ref, p2: ref) returns (i1) { (if $ne.i64.bool(p1, p2) then 1 else 0) }
function {:define} $ne.ref.bool(p1: ref, p2: ref) returns (bool) { $ne.i64.bool(p1, p2) }
function {:define} $ugt.ref(p1: ref, p2: ref) returns (i1) { (if $ugt.i64.bool(p1, p2) then 1 else 0) }
function {:define} $ugt.ref.bool(p1: ref, p2: ref) returns (bool) { $ugt.i64.bool(p1, p2) }
function {:define} $uge.ref(p1: ref, p2: ref) returns (i1) { (if $uge.i64.bool(p1, p2) then 1 else 0) }
function {:define} $uge.ref.bool(p1: ref, p2: ref) returns (bool) { $uge.i64.bool(p1, p2) }
function {:define} $ult.ref(p1: ref, p2: ref) returns (i1) { (if $ult.i64.bool(p1, p2) then 1 else 0) }
function {:define} $ult.ref.bool(p1: ref, p2: ref) returns (bool) { $ult.i64.bool(p1, p2) }
function {:define} $ule.ref(p1: ref, p2: ref) returns (i1) { (if $ule.i64.bool(p1, p2) then 1 else 0) }
function {:define} $ule.ref.bool(p1: ref, p2: ref) returns (bool) { $ule.i64.bool(p1, p2) }
function {:define} $sgt.ref(p1: ref, p2: ref) returns (i1) { (if $sgt.i64.bool(p1, p2) then 1 else 0) }
function {:define} $sgt.ref.bool(p1: ref, p2: ref) returns (bool) { $sgt.i64.bool(p1, p2) }
function {:define} $sge.ref(p1: ref, p2: ref) returns (i1) { (if $sge.i64.bool(p1, p2) then 1 else 0) }
function {:define} $sge.ref.bool(p1: ref, p2: ref) returns (bool) { $sge.i64.bool(p1, p2) }
function {:define} $slt.ref(p1: ref, p2: ref) returns (i1) { (if $slt.i64.bool(p1, p2) then 1 else 0) }
function {:define} $slt.ref.bool(p1: ref, p2: ref) returns (bool) { $slt.i64.bool(p1, p2) }
function {:define} $sle.ref(p1: ref, p2: ref) returns (i1) { (if $sle.i64.bool(p1, p2) then 1 else 0) }
function {:define} $sle.ref.bool(p1: ref, p2: ref) returns (bool) { $sle.i64.bool(p1, p2) }

// Pointer load/store operations
function {:define} $load.ref(M: [ref] ref, p: ref) returns (ref) { M[p] }
function {:define} $store.ref(M: [ref] ref, p: ref, i: ref) returns ([ref] ref) { M[p := i] }

// Pointer conversion
function {:define} $bitcast.ref.ref(p: ref) returns (ref) { p }
function $extractvalue.ref(p: ref, i: int) returns (ref);
// Pointer-number conversion
function {:define} $p2i.ref.i8(p: ref) returns (i8) { $trunc.i64.i8(p) }
function {:define} $i2p.i8.ref(i: i8) returns (ref) { $zext.i8.i64(i) }
function {:define} $p2i.ref.i16(p: ref) returns (i16) { $trunc.i64.i16(p) }
function {:define} $i2p.i16.ref(i: i16) returns (ref) { $zext.i16.i64(i) }
function {:define} $p2i.ref.i32(p: ref) returns (i32) { $trunc.i64.i32(p) }
function {:define} $i2p.i32.ref(i: i32) returns (ref) { $zext.i32.i64(i) }
function {:define} $p2i.ref.i64(p: ref) returns (i64) { p }
function {:define} $i2p.i64.ref(i: i64) returns (ref) { i }

function $fp(ipart: int, fpart: int, epart: int) returns (float);
// Floating-point arithmetic operations
function $abs.float(f: float) returns (float);
function $round.float(f: float) returns (float);
function $sqrt.float(f: float) returns (float);
function $fadd.float(f1: float, f2: float) returns (float);
function $fsub.float(f1: float, f2: float) returns (float);
function $fmul.float(f1: float, f2: float) returns (float);
function $fdiv.float(f1: float, f2: float) returns (float);
function $frem.float(f1: float, f2: float) returns (float);
function $min.float(f1: float, f2: float) returns (float);
function $max.float(f1: float, f2: float) returns (float);
function $fma.float(f1: float, f2: float, f3: float) returns (float);
// Floating-point predicates
function $foeq.float.bool(f1: float, f2: float) returns (bool);
function $fole.float.bool(f1: float, f2: float) returns (bool);
function $folt.float.bool(f1: float, f2: float) returns (bool);
function $foge.float.bool(f1: float, f2: float) returns (bool);
function $fogt.float.bool(f1: float, f2: float) returns (bool);
function $fone.float.bool(f1: float, f2: float) returns (bool);
function $ford.float.bool(f1: float, f2: float) returns (bool);
function $fueq.float.bool(f1: float, f2: float) returns (bool);
function $fugt.float.bool(f1: float, f2: float) returns (bool);
function $fuge.float.bool(f1: float, f2: float) returns (bool);
function $fult.float.bool(f1: float, f2: float) returns (bool);
function $fule.float.bool(f1: float, f2: float) returns (bool);
function $fune.float.bool(f1: float, f2: float) returns (bool);
function $funo.float.bool(f1: float, f2: float) returns (bool);
function $ffalse.float.bool(f1: float, f2: float) returns (bool);
function $ftrue.float.bool(f1: float, f2: float) returns (bool);
// Floating-point/integer conversion
function $bitcast.float.i8(f: float) returns (i8);
function $bitcast.float.i16(f: float) returns (i16);
function $bitcast.float.i32(f: float) returns (i32);
function $bitcast.float.i64(f: float) returns (i64);
function $bitcast.float.i80(f: float) returns (i80);
function $bitcast.i8.float(i: i8) returns (float);
function $bitcast.i16.float(i: i16) returns (float);
function $bitcast.i32.float(i: i32) returns (float);
function $bitcast.i64.float(i: i64) returns (float);
function $bitcast.i80.float(i: i80) returns (float);
function $fp2si.float.i1(f: float) returns (i1);
function $fp2si.float.i5(f: float) returns (i5);
function $fp2si.float.i6(f: float) returns (i6);
function $fp2si.float.i8(f: float) returns (i8);
function $fp2si.float.i16(f: float) returns (i16);
function $fp2si.float.i24(f: float) returns (i24);
function $fp2si.float.i32(f: float) returns (i32);
function $fp2si.float.i40(f: float) returns (i40);
function $fp2si.float.i48(f: float) returns (i48);
function $fp2si.float.i56(f: float) returns (i56);
function $fp2si.float.i64(f: float) returns (i64);
function $fp2si.float.i80(f: float) returns (i80);
function $fp2si.float.i88(f: float) returns (i88);
function $fp2si.float.i96(f: float) returns (i96);
function $fp2si.float.i128(f: float) returns (i128);
function $fp2si.float.i160(f: float) returns (i160);
function $fp2si.float.i256(f: float) returns (i256);
function $fp2ui.float.i1(f: float) returns (i1);
function $fp2ui.float.i5(f: float) returns (i5);
function $fp2ui.float.i6(f: float) returns (i6);
function $fp2ui.float.i8(f: float) returns (i8);
function $fp2ui.float.i16(f: float) returns (i16);
function $fp2ui.float.i24(f: float) returns (i24);
function $fp2ui.float.i32(f: float) returns (i32);
function $fp2ui.float.i40(f: float) returns (i40);
function $fp2ui.float.i48(f: float) returns (i48);
function $fp2ui.float.i56(f: float) returns (i56);
function $fp2ui.float.i64(f: float) returns (i64);
function $fp2ui.float.i80(f: float) returns (i80);
function $fp2ui.float.i88(f: float) returns (i88);
function $fp2ui.float.i96(f: float) returns (i96);
function $fp2ui.float.i128(f: float) returns (i128);
function $fp2ui.float.i160(f: float) returns (i160);
function $fp2ui.float.i256(f: float) returns (i256);
function $si2fp.i1.float(i: i1) returns (float);
function $si2fp.i5.float(i: i5) returns (float);
function $si2fp.i6.float(i: i6) returns (float);
function $si2fp.i8.float(i: i8) returns (float);
function $si2fp.i16.float(i: i16) returns (float);
function $si2fp.i24.float(i: i24) returns (float);
function $si2fp.i32.float(i: i32) returns (float);
function $si2fp.i40.float(i: i40) returns (float);
function $si2fp.i48.float(i: i48) returns (float);
function $si2fp.i56.float(i: i56) returns (float);
function $si2fp.i64.float(i: i64) returns (float);
function $si2fp.i80.float(i: i80) returns (float);
function $si2fp.i88.float(i: i88) returns (float);
function $si2fp.i96.float(i: i96) returns (float);
function $si2fp.i128.float(i: i128) returns (float);
function $si2fp.i160.float(i: i160) returns (float);
function $si2fp.i256.float(i: i256) returns (float);
function $ui2fp.i1.float(i: i1) returns (float);
function $ui2fp.i5.float(i: i5) returns (float);
function $ui2fp.i6.float(i: i6) returns (float);
function $ui2fp.i8.float(i: i8) returns (float);
function $ui2fp.i16.float(i: i16) returns (float);
function $ui2fp.i24.float(i: i24) returns (float);
function $ui2fp.i32.float(i: i32) returns (float);
function $ui2fp.i40.float(i: i40) returns (float);
function $ui2fp.i48.float(i: i48) returns (float);
function $ui2fp.i56.float(i: i56) returns (float);
function $ui2fp.i64.float(i: i64) returns (float);
function $ui2fp.i80.float(i: i80) returns (float);
function $ui2fp.i88.float(i: i88) returns (float);
function $ui2fp.i96.float(i: i96) returns (float);
function $ui2fp.i128.float(i: i128) returns (float);
function $ui2fp.i160.float(i: i160) returns (float);
function $ui2fp.i256.float(i: i256) returns (float);
// Floating-point conversion
function $fpext.float.float(f: float) returns (float);
function $fptrunc.float.float(f: float) returns (float);
// Floating-point load/store operations
function {:define} $load.float(M: [ref] float, p: ref) returns (float) { M[p] }
function {:define} $store.float(M: [ref] float, p: ref, f: float) returns ([ref] float) { M[p := f] }
function {:define} $load.unsafe.float(M: [ref] i8, p: ref) returns (float) { $bitcast.i8.float(M[p]) }
function {:define} $store.unsafe.float(M: [ref] i8, p: ref, f: float) returns ([ref] i8) { M[p := $bitcast.float.i8(f)] }
function $extractvalue.float(p: ref, i: int) returns (float);
const {:count 14} .str.2: ref;
axiom (.str.2 == $sub.ref(0, 1038));
const env_value_str: ref;
axiom (env_value_str == $sub.ref(0, 2070));
const {:count 3} .str.1.3: ref;
axiom (.str.1.3 == $sub.ref(0, 3097));
const {:count 14} .str.20: ref;
axiom (.str.20 == $sub.ref(0, 4135));
const errno_global: ref;
axiom (errno_global == $sub.ref(0, 5163));
const resetArray: ref;
axiom (resetArray == $sub.ref(0, 6195));
procedure {:inline 11} resetArray($p0: ref)
{
  var $i1: i32;
  var $i2: i1;
  var $i3: i64;
  var $p4: ref;
  var $i5: i32;
$bb0:
  assume {:sourceloc "two_arrays.c", 16, 8} true;
  assume {:verifier.code 0} true;
  assume {:sourceloc "two_arrays.c", 16, 8} true;
  assume {:verifier.code 0} true;
  $i1 := 0;
  goto $bb1;
$bb1:
  assume {:sourceloc "two_arrays.c", 0, 0} true;
  assume {:verifier.code 0} true;
  assume {:sourceloc "two_arrays.c", 16, 17} true;
  assume {:verifier.code 0} true;
  $i2 := $slt.i32($i1, 10);
  assume {:sourceloc "two_arrays.c", 16, 3} true;
  assume {:verifier.code 0} true;
  assume {:branchcond $i2} true;
  goto $bb2, $bb3;
$bb2:
  assume ($i2 == 1);
  assume {:sourceloc "two_arrays.c", 17, 5} true;
  assume {:verifier.code 0} true;
  $i3 := $sext.i32.i64($i1);
  assume {:sourceloc "two_arrays.c", 17, 5} true;
  assume {:verifier.code 0} true;
  $p4 := $add.ref($p0, $mul.ref($i3, 4));
  assume {:sourceloc "two_arrays.c", 17, 14} true;
  assume {:verifier.code 0} true;
  $M.0 := $store.i32($M.0, $p4, 0);
  assume {:sourceloc "two_arrays.c", 18, 3} true;
  assume {:verifier.code 0} true;
  goto $bb4;
$bb3:
  assume !(($i2 == 1));
  assume {:sourceloc "two_arrays.c", 19, 1} true;
  assume {:verifier.code 0} true;
  $exn := false;
  return;
$bb4:
  assume {:sourceloc "two_arrays.c", 16, 29} true;
  assume {:verifier.code 0} true;
  $i5 := $add.i32($i1, 1);
  call {:cexpr "i"} boogie_si_record_i32($i5);
  assume {:sourceloc "two_arrays.c", 16, 3} true;
  assume {:verifier.code 0} true;
  $i1 := $i5;
  goto $bb1;
}
const setArray: ref;
axiom (setArray == $sub.ref(0, 7227));
procedure {:inline 11} setArray($p0: ref)
{
  var $i1: i32;
  var $i2: i1;
  var $i3: i64;
  var $p4: ref;
  var $i5: i32;
$bb0:
  assume {:sourceloc "two_arrays.c", 24, 8} true;
  assume {:verifier.code 0} true;
  assume {:sourceloc "two_arrays.c", 24, 8} true;
  assume {:verifier.code 0} true;
  $i1 := 0;
  goto $bb1;
$bb1:
  assume {:sourceloc "two_arrays.c", 0, 0} true;
  assume {:verifier.code 0} true;
  assume {:sourceloc "two_arrays.c", 24, 17} true;
  assume {:verifier.code 0} true;
  $i2 := $slt.i32($i1, 10);
  assume {:sourceloc "two_arrays.c", 24, 3} true;
  assume {:verifier.code 0} true;
  assume {:branchcond $i2} true;
  goto $bb2, $bb3;
$bb2:
  assume ($i2 == 1);
  assume {:sourceloc "two_arrays.c", 25, 5} true;
  assume {:verifier.code 0} true;
  $i3 := $sext.i32.i64($i1);
  assume {:sourceloc "two_arrays.c", 25, 5} true;
  assume {:verifier.code 0} true;
  $p4 := $add.ref($p0, $mul.ref($i3, 4));
  assume {:sourceloc "two_arrays.c", 25, 14} true;
  assume {:verifier.code 0} true;
  $M.0 := $store.i32($M.0, $p4, 1);
  assume {:sourceloc "two_arrays.c", 26, 3} true;
  assume {:verifier.code 0} true;
  goto $bb4;
$bb3:
  assume !(($i2 == 1));
  assume {:sourceloc "two_arrays.c", 27, 1} true;
  assume {:verifier.code 0} true;
  $exn := false;
  return;
$bb4:
  assume {:sourceloc "two_arrays.c", 24, 29} true;
  assume {:verifier.code 0} true;
  $i5 := $add.i32($i1, 1);
  call {:cexpr "i"} boogie_si_record_i32($i5);
  assume {:sourceloc "two_arrays.c", 24, 3} true;
  assume {:verifier.code 0} true;
  $i1 := $i5;
  goto $bb1;
}
const main: ref;
axiom (main == $sub.ref(0, 8259));
procedure {:entrypoint} main()
  returns ($r: i32)
{
  var $p0: ref;
  var $p1: ref;
  var $p2: ref;
  var $p3: ref;
  var $i4: i32;
  var $i5: i1;
  var $i6: i64;
  var $p7: ref;
  var $i8: i32;
  var $i9: i1;
  var $i10: i64;
  var $p11: ref;
  var $i12: i32;
  var $i13: i1;
  var $i14: i32;
  var $i15: i32;
  var $i16: i1;
  var $i17: i64;
  var $p18: ref;
  var $i19: i32;
  var $i20: i1;
  var $i21: i64;
  var $p22: ref;
  var $i23: i32;
  var $i24: i1;
  var $i25: i32;
  var $p26: ref;
  var $p27: ref;
$bb0:
  call $initialize();
  assume {:sourceloc "two_arrays.c", 31, 26} true;
  assume {:verifier.code 0} true;
  call {:cexpr "smack:entry:main"} boogie_si_record_ref(main);
  assume {:sourceloc "two_arrays.c", 31, 26} true;
  assume {:verifier.code 0} true;
  call $p0 := malloc(40);
  assume {:sourceloc "two_arrays.c", 31, 19} true;
  assume {:verifier.code 0} true;
  $p1 := $bitcast.ref.ref($p0);
  assume {:sourceloc "two_arrays.c", 32, 26} true;
  assume {:verifier.code 0} true;
  call $p2 := malloc(40);
  assume {:sourceloc "two_arrays.c", 32, 19} true;
  assume {:verifier.code 0} true;
  $p3 := $bitcast.ref.ref($p2);
  assume {:sourceloc "two_arrays.c", 34, 3} true;
  assume {:verifier.code 0} true;
  call resetArray($p1);
  assume {:sourceloc "two_arrays.c", 35, 3} true;
  assume {:verifier.code 0} true;
  call setArray($p3);
  assume {:sourceloc "two_arrays.c", 37, 8} true;
  assume {:verifier.code 0} true;
  $i4 := 0;
  goto $bb1;
$bb1:
  assume {:sourceloc "two_arrays.c", 0, 0} true;
  assume {:verifier.code 0} true;
  assume {:sourceloc "two_arrays.c", 37, 17} true;
  assume {:verifier.code 0} true;
  $i5 := $slt.i32($i4, 10);
  assume {:sourceloc "two_arrays.c", 37, 3} true;
  assume {:verifier.code 0} true;
  assume {:branchcond $i5} true;
  goto $bb2, $bb3;
$bb2:
  assume ($i5 == 1);
  assume {:sourceloc "two_arrays.c", 38, 5} true;
  assume {:verifier.code 0} true;
  goto $bb4;
$bb3:
  assume !(($i5 == 1));
  assume {:sourceloc "two_arrays.c", 42, 3} true;
  assume {:verifier.code 0} true;
  call setArray($p1);
  assume {:sourceloc "two_arrays.c", 43, 3} true;
  assume {:verifier.code 0} true;
  call resetArray($p3);
  assume {:sourceloc "two_arrays.c", 45, 8} true;
  assume {:verifier.code 0} true;
  $i15 := 0;
  goto $bb15;
$bb4:
  assume {:sourceloc "two_arrays.c", 38, 5} true;
  assume {:verifier.code 0} true;
  $i6 := $sext.i32.i64($i4);
  assume {:sourceloc "two_arrays.c", 38, 5} true;
  assume {:verifier.code 0} true;
  $p7 := $add.ref($p1, $mul.ref($i6, 4));
  assume {:sourceloc "two_arrays.c", 38, 5} true;
  assume {:verifier.code 0} true;
  $i8 := $load.i32($M.0, $p7);
  assume {:sourceloc "two_arrays.c", 38, 5} true;
  assume {:verifier.code 0} true;
  $i9 := $eq.i32($i8, 0);
  assume {:sourceloc "two_arrays.c", 38, 5} true;
  assume {:verifier.code 0} true;
  assume {:branchcond $i9} true;
  goto $bb5, $bb7;
$bb5:
  assume {:sourceloc "two_arrays.c", 38, 5} true;
  assume {:verifier.code 0} true;
  assume ($i9 == 1);
  goto $bb6;
$bb6:
  assume {:sourceloc "two_arrays.c", 38, 5} true;
  assume {:verifier.code 0} true;
  goto $bb8;
$bb7:
  assume !(($i9 == 1));
  assume {:sourceloc "two_arrays.c", 38, 5} true;
  assume {:verifier.code 1} true;
  call __VERIFIER_assert(0);
  assume {:sourceloc "two_arrays.c", 38, 5} true;
  assume {:verifier.code 0} true;
  goto $bb6;
$bb8:
  assume {:sourceloc "two_arrays.c", 39, 5} true;
  assume {:verifier.code 0} true;
  goto $bb9;
$bb9:
  assume {:sourceloc "two_arrays.c", 39, 5} true;
  assume {:verifier.code 0} true;
  $i10 := $sext.i32.i64($i4);
  assume {:sourceloc "two_arrays.c", 39, 5} true;
  assume {:verifier.code 0} true;
  $p11 := $add.ref($p3, $mul.ref($i10, 4));
  assume {:sourceloc "two_arrays.c", 39, 5} true;
  assume {:verifier.code 0} true;
  $i12 := $load.i32($M.0, $p11);
  assume {:sourceloc "two_arrays.c", 39, 5} true;
  assume {:verifier.code 0} true;
  $i13 := $eq.i32($i12, 1);
  assume {:sourceloc "two_arrays.c", 39, 5} true;
  assume {:verifier.code 0} true;
  assume {:branchcond $i13} true;
  goto $bb10, $bb12;
$bb10:
  assume {:sourceloc "two_arrays.c", 39, 5} true;
  assume {:verifier.code 0} true;
  assume ($i13 == 1);
  goto $bb11;
$bb11:
  assume {:sourceloc "two_arrays.c", 39, 5} true;
  assume {:verifier.code 0} true;
  goto $bb13;
$bb12:
  assume !(($i13 == 1));
  assume {:sourceloc "two_arrays.c", 39, 5} true;
  assume {:verifier.code 1} true;
  call __VERIFIER_assert(0);
  assume {:sourceloc "two_arrays.c", 39, 5} true;
  assume {:verifier.code 0} true;
  goto $bb11;
$bb13:
  assume {:sourceloc "two_arrays.c", 40, 3} true;
  assume {:verifier.code 0} true;
  goto $bb14;
$bb14:
  assume {:sourceloc "two_arrays.c", 37, 29} true;
  assume {:verifier.code 0} true;
  $i14 := $add.i32($i4, 1);
  call {:cexpr "i"} boogie_si_record_i32($i14);
  assume {:sourceloc "two_arrays.c", 37, 3} true;
  assume {:verifier.code 0} true;
  $i4 := $i14;
  goto $bb1;
$bb15:
  assume {:sourceloc "two_arrays.c", 0, 0} true;
  assume {:verifier.code 0} true;
  assume {:sourceloc "two_arrays.c", 45, 17} true;
  assume {:verifier.code 0} true;
  $i16 := $slt.i32($i15, 10);
  assume {:sourceloc "two_arrays.c", 45, 3} true;
  assume {:verifier.code 0} true;
  assume {:branchcond $i16} true;
  goto $bb16, $bb17;
$bb16:
  assume ($i16 == 1);
  assume {:sourceloc "two_arrays.c", 46, 5} true;
  assume {:verifier.code 0} true;
  goto $bb18;
$bb17:
  assume !(($i16 == 1));
  assume {:sourceloc "two_arrays.c", 50, 8} true;
  assume {:verifier.code 0} true;
  $p26 := $bitcast.ref.ref($p1);
  assume {:sourceloc "two_arrays.c", 50, 3} true;
  assume {:verifier.code 0} true;
  call free_($p26);
  assume {:sourceloc "two_arrays.c", 51, 8} true;
  assume {:verifier.code 0} true;
  $p27 := $bitcast.ref.ref($p3);
  assume {:sourceloc "two_arrays.c", 51, 3} true;
  assume {:verifier.code 0} true;
  call free_($p27);
  assume {:sourceloc "two_arrays.c", 52, 3} true;
  assume {:verifier.code 0} true;
  $r := 0;
  $exn := false;
  return;
$bb18:
  assume {:sourceloc "two_arrays.c", 46, 5} true;
  assume {:verifier.code 0} true;
  $i17 := $sext.i32.i64($i15);
  assume {:sourceloc "two_arrays.c", 46, 5} true;
  assume {:verifier.code 0} true;
  $p18 := $add.ref($p1, $mul.ref($i17, 4));
  assume {:sourceloc "two_arrays.c", 46, 5} true;
  assume {:verifier.code 0} true;
  $i19 := $load.i32($M.0, $p18);
  assume {:sourceloc "two_arrays.c", 46, 5} true;
  assume {:verifier.code 0} true;
  $i20 := $eq.i32($i19, 1);
  assume {:sourceloc "two_arrays.c", 46, 5} true;
  assume {:verifier.code 0} true;
  assume {:branchcond $i20} true;
  goto $bb19, $bb21;
$bb19:
  assume {:sourceloc "two_arrays.c", 46, 5} true;
  assume {:verifier.code 0} true;
  assume ($i20 == 1);
  goto $bb20;
$bb20:
  assume {:sourceloc "two_arrays.c", 46, 5} true;
  assume {:verifier.code 0} true;
  goto $bb22;
$bb21:
  assume !(($i20 == 1));
  assume {:sourceloc "two_arrays.c", 46, 5} true;
  assume {:verifier.code 1} true;
  call __VERIFIER_assert(0);
  assume {:sourceloc "two_arrays.c", 46, 5} true;
  assume {:verifier.code 0} true;
  goto $bb20;
$bb22:
  assume {:sourceloc "two_arrays.c", 47, 5} true;
  assume {:verifier.code 0} true;
  goto $bb23;
$bb23:
  assume {:sourceloc "two_arrays.c", 47, 5} true;
  assume {:verifier.code 0} true;
  $i21 := $sext.i32.i64($i15);
  assume {:sourceloc "two_arrays.c", 47, 5} true;
  assume {:verifier.code 0} true;
  $p22 := $add.ref($p3, $mul.ref($i21, 4));
  assume {:sourceloc "two_arrays.c", 47, 5} true;
  assume {:verifier.code 0} true;
  $i23 := $load.i32($M.0, $p22);
  assume {:sourceloc "two_arrays.c", 47, 5} true;
  assume {:verifier.code 0} true;
  $i24 := $eq.i32($i23, 0);
  assume {:sourceloc "two_arrays.c", 47, 5} true;
  assume {:verifier.code 0} true;
  assume {:branchcond $i24} true;
  goto $bb24, $bb26;
$bb24:
  assume {:sourceloc "two_arrays.c", 47, 5} true;
  assume {:verifier.code 0} true;
  assume ($i24 == 1);
  goto $bb25;
$bb25:
  assume {:sourceloc "two_arrays.c", 47, 5} true;
  assume {:verifier.code 0} true;
  goto $bb27;
$bb26:
  assume !(($i24 == 1));
  assume {:sourceloc "two_arrays.c", 47, 5} true;
  assume {:verifier.code 1} true;
  call __VERIFIER_assert(0);
  assume {:sourceloc "two_arrays.c", 47, 5} true;
  assume {:verifier.code 0} true;
  goto $bb25;
$bb27:
  assume {:sourceloc "two_arrays.c", 48, 3} true;
  assume {:verifier.code 0} true;
  goto $bb28;
$bb28:
  assume {:sourceloc "two_arrays.c", 45, 29} true;
  assume {:verifier.code 0} true;
  $i25 := $add.i32($i15, 1);
  call {:cexpr "i"} boogie_si_record_i32($i25);
  assume {:sourceloc "two_arrays.c", 45, 3} true;
  assume {:verifier.code 0} true;
  $i15 := $i25;
  goto $bb15;
}
const malloc: ref;
axiom (malloc == $sub.ref(0, 9291));
procedure {:inline 11} malloc($i0: i64)
  returns ($r: ref)
{
  call $r := $malloc($i0);
}
const free_: ref;
axiom (free_ == $sub.ref(0, 10323));
procedure {:inline 11} free_($p0: ref)
{
  call $free($p0);
}
const __VERIFIER_assume: ref;
axiom (__VERIFIER_assume == $sub.ref(0, 11355));
procedure {:inline 11} __VERIFIER_assume($i0: i32)
{
$bb0:
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 258, 29} true;
  assume {:verifier.code 1} true;
  call {:cexpr "__VERIFIER_assume:arg:x"} boogie_si_record_i32($i0);
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 258, 29} true;
  assume {:verifier.code 1} true;
  assume true;
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 38, 3} true;
  assume {:verifier.code 1} true;
  assume $i0 != $0;
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 39, 1} true;
  assume {:verifier.code 0} true;
  $exn := false;
  return;
}
const __SMACK_code: ref;
axiom (__SMACK_code == $sub.ref(0, 12387));
procedure {:inline 11} __SMACK_code.ref($p0: ref);
procedure {:inline 11} __SMACK_code.ref.i32($p0: ref, p.1: i32);
const __SMACK_dummy: ref;
axiom (__SMACK_dummy == $sub.ref(0, 13419));
procedure {:inline 11} __SMACK_dummy($i0: i32)
{
$bb0:
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 258, 29} true;
  assume {:verifier.code 1} true;
  call {:cexpr "__SMACK_dummy:arg:v"} boogie_si_record_i32($i0);
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 258, 29} true;
  assume {:verifier.code 1} true;
  assume true;
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 258, 59} true;
  assume {:verifier.code 0} true;
  $exn := false;
  return;
}
const __VERIFIER_assert: ref;
axiom (__VERIFIER_assert == $sub.ref(0, 14451));
procedure {:inline 11} __VERIFIER_assert($i0: i32)
{
$bb0:
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 258, 29} true;
  assume {:verifier.code 1} true;
  call {:cexpr "__VERIFIER_assert:arg:x"} boogie_si_record_i32($i0);
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 258, 29} true;
  assume {:verifier.code 1} true;
  assume true;
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 45, 3} true;
  assume {:verifier.code 1} true;
  assert $i0 != $0;
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 47, 1} true;
  assume {:verifier.code 0} true;
  $exn := false;
  return;
}
const __SMACK_check_overflow: ref;
axiom (__SMACK_check_overflow == $sub.ref(0, 15483));
procedure {:inline 11} __SMACK_check_overflow($i0: i32)
{
$bb0:
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 258, 29} true;
  assume {:verifier.code 1} true;
  call {:cexpr "__SMACK_check_overflow:arg:flag"} boogie_si_record_i32($i0);
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 258, 29} true;
  assume {:verifier.code 1} true;
  assume true;
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 63, 3} true;
  assume {:verifier.code 1} true;
  assert {:overflow} $i0 == $0;
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 64, 1} true;
  assume {:verifier.code 0} true;
  $exn := false;
  return;
}
const __SMACK_nondet_char: ref;
axiom (__SMACK_nondet_char == $sub.ref(0, 16515));
procedure {:inline 11} __SMACK_nondet_char()
  returns ($r: i8);
const __SMACK_nondet_signed_char: ref;
axiom (__SMACK_nondet_signed_char == $sub.ref(0, 17547));
procedure {:inline 11} __SMACK_nondet_signed_char()
  returns ($r: i8);
const __SMACK_nondet_unsigned_char: ref;
axiom (__SMACK_nondet_unsigned_char == $sub.ref(0, 18579));
procedure {:inline 11} __SMACK_nondet_unsigned_char()
  returns ($r: i8);
const __SMACK_nondet_short: ref;
axiom (__SMACK_nondet_short == $sub.ref(0, 19611));
procedure {:inline 11} __SMACK_nondet_short()
  returns ($r: i16);
const __SMACK_nondet_signed_short: ref;
axiom (__SMACK_nondet_signed_short == $sub.ref(0, 20643));
procedure {:inline 11} __SMACK_nondet_signed_short()
  returns ($r: i16);
const __SMACK_nondet_signed_short_int: ref;
axiom (__SMACK_nondet_signed_short_int == $sub.ref(0, 21675));
procedure {:inline 11} __SMACK_nondet_signed_short_int()
  returns ($r: i16);
const __SMACK_nondet_unsigned_short: ref;
axiom (__SMACK_nondet_unsigned_short == $sub.ref(0, 22707));
procedure {:inline 11} __SMACK_nondet_unsigned_short()
  returns ($r: i16);
const __SMACK_nondet_unsigned_short_int: ref;
axiom (__SMACK_nondet_unsigned_short_int == $sub.ref(0, 23739));
procedure {:inline 11} __SMACK_nondet_unsigned_short_int()
  returns ($r: i16);
const __SMACK_nondet_int: ref;
axiom (__SMACK_nondet_int == $sub.ref(0, 24771));
procedure {:inline 11} __SMACK_nondet_int()
  returns ($r: i32);
const __SMACK_nondet_signed_int: ref;
axiom (__SMACK_nondet_signed_int == $sub.ref(0, 25803));
procedure {:inline 11} __SMACK_nondet_signed_int()
  returns ($r: i32);
const __SMACK_nondet_unsigned: ref;
axiom (__SMACK_nondet_unsigned == $sub.ref(0, 26835));
procedure {:inline 11} __SMACK_nondet_unsigned()
  returns ($r: i32);
const __SMACK_nondet_unsigned_int: ref;
axiom (__SMACK_nondet_unsigned_int == $sub.ref(0, 27867));
procedure {:inline 11} __SMACK_nondet_unsigned_int()
  returns ($r: i32);
const __SMACK_nondet_long: ref;
axiom (__SMACK_nondet_long == $sub.ref(0, 28899));
procedure {:inline 11} __SMACK_nondet_long()
  returns ($r: i64);
const __SMACK_nondet_long_int: ref;
axiom (__SMACK_nondet_long_int == $sub.ref(0, 29931));
procedure {:inline 11} __SMACK_nondet_long_int()
  returns ($r: i64);
const __SMACK_nondet_signed_long: ref;
axiom (__SMACK_nondet_signed_long == $sub.ref(0, 30963));
procedure {:inline 11} __SMACK_nondet_signed_long()
  returns ($r: i64);
const __SMACK_nondet_signed_long_int: ref;
axiom (__SMACK_nondet_signed_long_int == $sub.ref(0, 31995));
procedure {:inline 11} __SMACK_nondet_signed_long_int()
  returns ($r: i64);
const __SMACK_nondet_unsigned_long: ref;
axiom (__SMACK_nondet_unsigned_long == $sub.ref(0, 33027));
procedure {:inline 11} __SMACK_nondet_unsigned_long()
  returns ($r: i64);
const __SMACK_nondet_unsigned_long_int: ref;
axiom (__SMACK_nondet_unsigned_long_int == $sub.ref(0, 34059));
procedure {:inline 11} __SMACK_nondet_unsigned_long_int()
  returns ($r: i64);
const __SMACK_nondet_long_long: ref;
axiom (__SMACK_nondet_long_long == $sub.ref(0, 35091));
procedure {:inline 11} __SMACK_nondet_long_long()
  returns ($r: i64);
const __SMACK_nondet_long_long_int: ref;
axiom (__SMACK_nondet_long_long_int == $sub.ref(0, 36123));
procedure {:inline 11} __SMACK_nondet_long_long_int()
  returns ($r: i64);
const __SMACK_nondet_signed_long_long: ref;
axiom (__SMACK_nondet_signed_long_long == $sub.ref(0, 37155));
procedure {:inline 11} __SMACK_nondet_signed_long_long()
  returns ($r: i64);
const __SMACK_nondet_signed_long_long_int: ref;
axiom (__SMACK_nondet_signed_long_long_int == $sub.ref(0, 38187));
procedure {:inline 11} __SMACK_nondet_signed_long_long_int()
  returns ($r: i64);
const __SMACK_nondet_unsigned_long_long: ref;
axiom (__SMACK_nondet_unsigned_long_long == $sub.ref(0, 39219));
procedure {:inline 11} __SMACK_nondet_unsigned_long_long()
  returns ($r: i64);
const __SMACK_nondet_unsigned_long_long_int: ref;
axiom (__SMACK_nondet_unsigned_long_long_int == $sub.ref(0, 40251));
procedure {:inline 11} __SMACK_nondet_unsigned_long_long_int()
  returns ($r: i64);
const __SMACK_decls: ref;
axiom (__SMACK_decls == $sub.ref(0, 41283));
type $mop;
procedure {:inline 11} boogie_si_record_mop(m: $mop);
const $MOP: $mop;
var $exn: bool;
var $exnv: int;
procedure {:inline 11} corral_atomic_begin();
procedure {:inline 11} corral_atomic_end();
procedure {:inline 11} $alloc(n: ref) returns (p: ref)
{
  call corral_atomic_begin();
  call p := $$alloc(n);
  call corral_atomic_end();
}

procedure {:inline 11} $malloc(n: ref) returns (p: ref)
{
  call corral_atomic_begin();
  call p := $$alloc(n);
  call corral_atomic_end();
}

var $CurrAddr:ref;

procedure {:inline 1} $$alloc(n: ref) returns (p: ref)
modifies $CurrAddr;
{
  assume $sge.ref.bool(n, $0.ref);
  if ($sgt.ref.bool(n, $0.ref)) {
    p := $CurrAddr;
    havoc $CurrAddr;
    assume $sge.ref.bool($sub.ref($CurrAddr, n), p);
    assume $sgt.ref.bool($CurrAddr, $0.ref) && $slt.ref.bool($CurrAddr, $MALLOC_TOP);
  } else {
    p := $0.ref;
  }
}

procedure {:inline 11} $free(p: ref);

const __SMACK_top_decl: ref;
axiom (__SMACK_top_decl == $sub.ref(0, 42315));
procedure {:inline 11} __SMACK_top_decl.ref($p0: ref);
const __SMACK_init_func_memory_model: ref;
axiom (__SMACK_init_func_memory_model == $sub.ref(0, 43347));
procedure {:inline 11} __SMACK_init_func_memory_model()
{
$bb0:
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 539, 3} true;
  assume {:verifier.code 1} true;
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 539, 3} true;
  assume {:verifier.code 1} true;
  $CurrAddr := $1024.ref;
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 544, 1} true;
  assume {:verifier.code 0} true;
  $exn := false;
  return;
}
const __VERIFIER_atomic_begin: ref;
axiom (__VERIFIER_atomic_begin == $sub.ref(0, 44379));
procedure {:inline 11} __VERIFIER_atomic_begin()
{
$bb0:
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 546, 34} true;
  assume {:verifier.code 1} true;
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 546, 34} true;
  assume {:verifier.code 1} true;
  call corral_atomic_begin();
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 546, 79} true;
  assume {:verifier.code 0} true;
  $exn := false;
  return;
}
const __VERIFIER_atomic_end: ref;
axiom (__VERIFIER_atomic_end == $sub.ref(0, 45411));
procedure {:inline 11} __VERIFIER_atomic_end()
{
$bb0:
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 548, 32} true;
  assume {:verifier.code 1} true;
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 548, 32} true;
  assume {:verifier.code 1} true;
  call corral_atomic_end();
  assume {:sourceloc "/usr/local/share/smack/lib/smack.c", 548, 75} true;
  assume {:verifier.code 0} true;
  $exn := false;
  return;
}
const llvm.dbg.value: ref;
axiom (llvm.dbg.value == $sub.ref(0, 46443));
procedure {:inline 11} llvm.dbg.value($p0: ref, $p1: ref, $p2: ref);
const __SMACK_static_init: ref;
axiom (__SMACK_static_init == $sub.ref(0, 47475));
procedure {:inline 11} __SMACK_static_init()
{
$bb0:
  $M.1 := .str.1.3;
  $M.2 := 0;
  call {:cexpr "errno_global"} boogie_si_record_i32(0);
  $exn := false;
  return;
}
procedure {:inline 11} boogie_si_record_i32(x: i32);
procedure {:inline 11} boogie_si_record_ref(x: ref);
procedure {:inline 11} $initialize()
{
  call __SMACK_static_init();
  call __SMACK_init_func_memory_model();
  return;
}
